/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parser.y" /* yacc.c:339  */

/*
 *  Destruction for Dummies Definition Language
 *
 *  Language for defining a class's actions for Destruction for Dummies.
 *
 *  This takes as input a .dddl file, and produces a .lua file as output
 *
 *  Format:
 *
 *  ---------------
 *
 *  Class: <class>;
 *  Build: <talent build>;
 *
 *  <variables>
 *
 *  InCombat [ (resource : spell) ]
 *              // the resource: spell is the resource to watch for running
 *              // out of, and the spell to cast if you do (like Life Tap for
 *              // mana, or Tiger's Fury for energy)
 *
 *      clip {                  // define the clip times
 *          spell: <num>;       // time in seconds
 *              ...
 *      };
 *
 *      strict {
 *          // strict order rotation.  These are things that will cause an
 *          // absolute selection, irrespective of cooldown, mana, etc.  For
 *          // example, kitty form for a druid.  Should only be used if other
 *          // choices depend on it.
 *
 *          <strict rotation>
 *      };
 *
 *      alternative {
 *          // this for the alternative recommendation
 *      };
 *
 *      <soonest rotation>
 *  };
 *
 *  OutOfCombat [ (resource : spell) ] {
 *      <soonest rotation>
 *  };
 *
 *  The rotation can make use of the following functions:
 *      Buff("buff")            -- true if player has the buff
 *      BuffInfo("buff")        -- return time left and stack count
 *      PetBuff("buff")         -- true if your pet has the buff
 *      PlayerDebuff("debuff")  -- true if the player has the debuff
 *      Debuff("debuff")        -- true if target has debuff up
 *      DebuffByMe("debuff")    -- true if target has the debuff from player
 *      DebuffInfo("debuff")    -- return time left and stack count
 *      DebuffByMeInfo("debuff")-- return time left and stack count
 *      AuraCount("aura")       -- returns the count of the aura on the player
 *
 *
 *      The following three return times for the buff/debuff.  If
 *      multiple instances of the aura are present, the time for the
 *      player's is returned, otherwise the time for the one falling
 *      off last.
 *
 *      They return the time left on aura in seconds, 0 if permanent
 *      or down
 *
 *      BuffTime("buff")
 *      DebuffTime("buff")      -- returns shortest time left on debuff
 *      DebuffByMeTime("buff")  -- returns time left on debuff by me
 *
 *
 *
 *      Known("spell")          -- True if the user knows the spell
 *      LastCast("spell")       -- the passed spell was the last one we cast
 *      GCD("spell")            -- GCD triggered by this spell
 *      Cooldown("spell")       -- Remaining cooldown time on this spell
 *      Charges("spell")        -- Number of and max charges on the spell
 *      ChargeInfo("spell")     -- Full info on charges
 *          -- Number of charges, max charges, time (in seconds) to next charge
 *
 *      Solo()                  -- true if the player is solo questing (not
 *                                 in a party or raid)
 *      InParty()               -- true if in a party (but not a raid)
 *      InRaid()                -- true if in a raid
 *
 *      Stance(exp)             -- true if we are in the given stance
 *                                 Stance numbers are the same as in the
 *                                 GetShapeshiftFormInfo() API from Bliz.
 *
 *      DualWielding()          -- true if player has two weapons equipped
 *
 *      Totem("spell")          -- Amount of time that totem has remaining,
 *                                 or nil if not down
 *
 *      TotemType(number)       -- Return info about the passed in totem
 *              -- totem numbers: Fire = 1, Earth = 2, Water = 3, Air = 4
 *              -- returns haveTotem, totemName, remainingTime
 *
 *      (Note: the following two routines differ in the way they treat death
 *      runes.  RuneCount returns the number of runes of that type that are
 *      fully cooled (so a blood rune that is now a death rune only counts for
 *      tests on blood runes).  This is primarily useful for tests to see
 *      whether both of a rune are up (which will cause us to want a cast that
 *      will start one cooling).  HaveRunes will treat death runes as wild
 *      cards, and is mainly useful for tests to see whether you can cast
 *      a spell.  As of WoW 4.0.6 there is a weird inconsistency in clients;
 *      my client will show a spell on cooldown while its runes are cooling,
 *      at least one of my users' does not.)
 *      RuneCount(runetype)     -- returns the number of that type of rune
 *      HaveRunes(b,f,u)        -- returns true if we have at least the
 *                              -- specified number of blood, frost, and death
 *                              -- runes
 *
 *      (Note: the following two functions differ in that HasPet() returns
 *      true if the pet is available.  PetExists() returns true if the pet
 *      is available or will become available when you dismount or get out
 *      of the vehicle.  Except this doesn't seem exactly true.  Sigh)
 *      HasPet()                -- True if a pet is out
 *      PetExists()             -- True if a pet has been called
 *
 *      PetHealth()             -- Pet's health as a percent of max health
 *      TargetHealth()          -- Target's health as a percent of max health
 *      PlayerHealth()          -- Player's health as a percent of max health
 *      RawPlayerHealth()       -- Players current and max health
 *
 *      Power([type])           -- Player's current power, as a percentage
 *      RawPower([type])        -- Player's current power, as a raw number
 *      MaxPower([type])        -- Player's max power, as a raw number
 *         The power functions take an optional power type as a string
 *         (taken from http://wow.gamepedia.com/PowerType).  Legal values are:
 *             "mana"           "rage"          "focus"         "energy"
 *             "combo_points"   "runes"         "runic"         "soul_shards"
 *             "eclipse"        "holy"          "alternate"     "dark_force"
 *             "chi"            "shadow_orbs"   "burning_embers" "demonic_fury"
 *
 *      Distance()              -- Yards to target (best guess)
 *      RangedCombat("ranged spell")
 *                              -- True if we are at ranged or greater combat
 *                                 distance.  You must give a ranged spell
 *                                 that we can test on.  Best to give one with
 *                                 no mana requirements
 *
 *      FlaggedPVP()            -- True if you are currently flagged for PVP
 *      HasGlyph("glyph")       -- True if they have the glyph
 *
 *      Threat()                -- UnitDetailedThreatStatus(), with nils
 *                                 changed to 0's
 *
 *      CreatureType("type")    -- true if the target is the passed type
 *      Boss()                  -- true if the target is a boss (elite,
 *                                 three or more levels above you)
 *      TimeToDie()             -- Est. time until target dies (in seconds)
 *
 *
 *      FerralMode()            -- true if player does not want help with
 *                                 regular rotation spells
 *
 *      Talent()                -- returns true if we have that talent
 *
 *      Tapped()                -- returns true if the target is tapped by
 *                                 another player
 *
 *      Uptime()                -- current system uptime in seconds
 *
 *      OnTank()                -- true if the current mob is targeting a tank
 *
 *      InBag()                 -- returns true,bagno,slotno if item is in bag
 *
 *  There are three functions that take Mutex'es.  They just look to see if
 *  one of the things are there--no clipping is considered.  If the buff/debuff
 *  is up, it returns true:
 *      MxBuff(mutex_number)
 *      MxBuffByMe(mutex_number)
 *      MxDebuff(mutex_number)
 *      MxDebuffByMe(mutex_number)
 *
 *
 *  There are some text-handling functions:
 *      SpellText(spell)        -- returns the text from the spellbook for that
 *                                 spell
 *
 *      ScanNumbers(text, count)-- scans the text for all numbers in it, and
 *                                 returns the <count> of them.  <count> must
 *                                 be less than 5
 *
 *  The builtin funcs come in the following flavors:
 *      BUILTIN_1       -- takes no parameters
 *
 *      BUILTIN_2       -- takes a spell as a parameter.  if none is given,
 *                         we will insert the current spell name
 *
 *      BUILTIN_2M      -- Takes a spell as a parameter.  Must be given
 *
 *      BUILTIN_3       -- Takes a number as a parameter
 *
 *      BUILTIN_4       -- Takes an optional string as a parameter
 *
 *      BUILTIN_5       -- Takes 3 numbers as parameters
 *
 *      BUILTIN_6       -- Takes an item as a paremeter.  If none is given,
 *                         we will insert the current item
 *
 *      BUILTIN_7       -- Takes a glyph as parameter
 *
 *      BUILTIN_8       -- Takes a talent as parameter
 *
 *      BUILTIN_9       -- Takes two expressions as parameters
 *
 *      BUILTIN_MX      -- Takes a mutex
 *
 *      BUILTIN_MX2     -- Takes a mutex and a spell
 *
 *
 *  Program accepts C and C++ style comments
 *
 *  Spells *must* be entered inside double quotes
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
#include <unistd.h>
#include <stdlib.h>
#include <libgen.h>
#include <stdbool.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "builtin.h"
#include "parser.h"
#include "strings.h"

#undef YYDEBUG
#define YYDEBUG 1

#define MAX_SWITCH_COUNT        1024    // max # of switches in dddl file
#define BIG_NUMBER               512    // size of arrays that need to be big

#define NELEM(n)        (sizeof(n) / sizeof(*(n)))

#ifdef __APPLE__
#  define       CMD_CPP         "/usr/bin/cpp -Wno-invalid-pp-token"
#else
#  define       CMD_CPP         "/lib/cpp"
#endif

char *classname, *buildname;
static struct thing cur_thing;
static char *curvar;
static int curvar_array;
static bool have_incombat = false, have_oocombat = false;

static enum { RM_NORMAL, RM_STRICT, RM_ALTERNATE } rotMode = RM_NORMAL;
static int switchcount = 0, cur_switchnum;
static short seen_case[MAX_SWITCH_COUNT];
static short seen_a_case = 0;

extern char *yytext;
extern int yylex();
extern int yyerror(char *);

// forward declarations
static char *aura2clip(int);
static char *proc_builtin1(enum built_in);
static char *proc_builtin2(enum built_in, const struct thing * const);
static char *proc_builtin3(enum built_in, char *);
static char *proc_builtin4(enum built_in, char *);
static char *proc_builtin5(enum built_in, char *, char *, char *);
static char *proc_builtin6(enum built_in, struct thing *);
static char *proc_builtin7(enum built_in, int);
static char *proc_builtin8(enum built_in, const struct thing * const);
static char *proc_builtin9(enum built_in, const char *text, const char *count);
static char *proc_builtin_mx(enum built_in, int);
static char *proc_builtin_mx2(enum built_in, int, char *);
static void have_clip(int, char *);
static char *find_clip(const struct thing *thing);
static void indent(int);
static char *normalize(char *);
static char *upstring(char *);
static char *intstring(const int i);

static struct cliplist {
    struct cliplist *next;
    int aura;
    char *clip;
} *firstclip = NULL;

int lineno;
char *filename = NULL;
bool had_error = false;

static int indent_level = 0;
static int mIndex = 0;          // which mutex number we are on
static int cur_mutexno = 0;     // which entry in our mutex we are on
static int utilOK = 0;
static char *free_spell = NULL;
static char *fail_spell = NULL;
static int altnum = 0;
static int debugging = 0;

#line 369 "parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.h".  */
#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_CLASS = 258,
    T_BUILD = 259,
    T_COMBAT = 260,
    T_OUTOFCOMBAT = 261,
    T_CLIP = 262,
    T_STRICT = 263,
    T_FLOAT = 264,
    T_INTEGER = 265,
    T_PRECOMBAT = 266,
    T_POSTSPELL = 267,
    T_SPELLSENT = 268,
    T_NIL = 269,
    T_ID = 270,
    T_ABSVAL = 271,
    T_SPELL = 272,
    T_ITEM = 273,
    T_AURA = 274,
    T_GLYPH = 275,
    T_TALENT = 276,
    T_STRING = 277,
    T_TAKE_DAMAGE = 278,
    T_TAKE_HEAL = 279,
    T_TRUE = 280,
    T_FALSE = 281,
    T_BUILTIN_1 = 282,
    T_BUILTIN_2 = 283,
    T_BUILTIN_2M = 284,
    T_BUILTIN_3 = 285,
    T_BUILTIN_4 = 286,
    T_BUILTIN_5 = 287,
    T_BUILTIN_6 = 288,
    T_BUILTIN_7 = 289,
    T_BUILTIN_8 = 290,
    T_BUILTIN_9 = 291,
    T_BUILTIN_MX = 292,
    T_BUILTIN_MX2 = 293,
    T_SWITCH = 294,
    T_CASE = 295,
    T_DEFAULT = 296,
    T_IF = 297,
    T_ELSEIF = 298,
    T_ELSE = 299,
    T_EXTERN = 300,
    T_FUNCTION = 301,
    T_WHILE = 302,
    T_ALTERNATE = 303,
    T_MUTEX = 304,
    T_MUTEXVAR = 305,
    T_FREE = 306,
    T_FAIL = 307,
    T_PRINT = 308,
    T_CALL = 309,
    T_VAR = 310,
    T_VARIABLE = 311,
    T_EXTERNVARIABLE = 312,
    T_OR = 313,
    T_AND = 314,
    T_GEQ = 315,
    T_NEQ = 316,
    T_LEQ = 317,
    T_EQ = 318,
    UNIMINUS = 319
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 485 "parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1525

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  82
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  110
/* YYNRULES -- Number of rules.  */
#define YYNRULES  217
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  438

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   319

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    70,     2,     2,     2,     2,     2,     2,
      76,    78,    68,    66,    79,    67,     2,    69,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    72,    73,
      64,    77,    65,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    80,     2,    81,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    74,     2,    75,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    71
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   330,   330,   330,   340,   341,   340,   361,   364,   363,
     379,   379,   385,   390,   396,   406,   407,   411,   417,   428,
     428,   432,   433,   433,   439,   449,   438,   472,   473,   477,
     478,   482,   483,   487,   488,   489,   494,   507,   512,   513,
     518,   532,   534,   538,   539,   544,   549,   550,   555,   556,
     558,   557,   569,   568,   585,   584,   598,   597,   611,   610,
     623,   625,   622,   645,   646,   651,   652,   663,   669,   674,
     673,   701,   703,   712,   717,   718,   723,   724,   728,   737,
     755,   756,   761,   762,   767,   766,   804,   804,   811,   810,
     818,   819,   823,   823,   826,   827,   832,   831,   851,   853,
     850,   858,   859,   864,   865,   870,   880,   881,   892,   893,
     897,   902,   903,   915,   916,   921,   922,   923,   924,   926,
     925,   953,   952,  1020,  1036,  1035,  1067,  1066,  1081,  1080,
    1093,  1094,  1095,  1103,  1102,  1114,  1115,  1126,  1135,  1139,
    1149,  1162,  1164,  1168,  1169,  1174,  1176,  1174,  1183,  1184,
    1188,  1204,  1207,  1206,  1217,  1218,  1222,  1223,  1228,  1227,
    1237,  1239,  1238,  1247,  1256,  1265,  1274,  1284,  1294,  1304,
    1314,  1324,  1334,  1344,  1354,  1364,  1374,  1384,  1394,  1402,
    1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,  1415,  1416,
    1420,  1421,  1425,  1436,  1448,  1450,  1454,  1458,  1463,  1468,
    1475,  1479,  1483,  1487,  1491,  1493,  1504,  1524,  1528,  1529,
    1530,  1531,  1532,  1537,  1538,  1543,  1544,  1548
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_CLASS", "T_BUILD", "T_COMBAT",
  "T_OUTOFCOMBAT", "T_CLIP", "T_STRICT", "T_FLOAT", "T_INTEGER",
  "T_PRECOMBAT", "T_POSTSPELL", "T_SPELLSENT", "T_NIL", "T_ID", "T_ABSVAL",
  "T_SPELL", "T_ITEM", "T_AURA", "T_GLYPH", "T_TALENT", "T_STRING",
  "T_TAKE_DAMAGE", "T_TAKE_HEAL", "T_TRUE", "T_FALSE", "T_BUILTIN_1",
  "T_BUILTIN_2", "T_BUILTIN_2M", "T_BUILTIN_3", "T_BUILTIN_4",
  "T_BUILTIN_5", "T_BUILTIN_6", "T_BUILTIN_7", "T_BUILTIN_8",
  "T_BUILTIN_9", "T_BUILTIN_MX", "T_BUILTIN_MX2", "T_SWITCH", "T_CASE",
  "T_DEFAULT", "T_IF", "T_ELSEIF", "T_ELSE", "T_EXTERN", "T_FUNCTION",
  "T_WHILE", "T_ALTERNATE", "T_MUTEX", "T_MUTEXVAR", "T_FREE", "T_FAIL",
  "T_PRINT", "T_CALL", "T_VAR", "T_VARIABLE", "T_EXTERNVARIABLE", "T_OR",
  "T_AND", "T_GEQ", "T_NEQ", "T_LEQ", "T_EQ", "'<'", "'>'", "'+'", "'-'",
  "'*'", "'/'", "'!'", "UNIMINUS", "':'", "';'", "'{'", "'}'", "'('",
  "'='", "')'", "','", "'['", "']'", "$accept", "file", "$@1", "header",
  "$@2", "$@3", "vardecl", "$@4", "$@5", ".mutexclip", "mx_spellist",
  "mx_spell", "vardecl_line", "$@6", "vardecl_actual", "$@7", "vardeclent",
  "$@8", "$@9", "mutexname", "varname", ".array", ".init", "single_init",
  "array_init", "array_init_lines", "array_init_line", ".optstuff",
  "optstuff", "optthang", "calledRoutines", "calledRoutine", "$@10",
  "$@11", "$@12", "$@13", "$@14", "@15", "@16", ".paramlist", "paramlist",
  "parameter", "incombat", "$@17", ".pick_opts", "just_one_opt",
  "pick_opts", "pick_opt", "failspell", "freespell", "oocombat", "$@18",
  "combatstuff", "$@19", "alternate", "$@20", ".alt_number", "clips",
  "$@21", "clipents", "clip", "$@22", "strict", "$@23", "$@24", "rotation",
  ".spell_predicate", "print_statement", "stuff2print", "printThang",
  "string", ".string", ".spell_mintime", "rotation_entry", "$@25", "$@26",
  "@27", "$@28", "$@29", "@30", "varlist", "t_variable",
  "t_externvariable", "variable", ".case_statements", "case_statements",
  "case_statement", "$@31", "$@32", "caselines", "one_case",
  ".default_statement", "$@33", ".elseifs", "elseifs", "elseif", "$@34",
  ".else", "$@35", "exp", ".arrayindex", "number", "integer", "float",
  "builtin", ".aura_or_spell", "thing", "aura_or_spell", ".item", "item", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,    60,    62,    43,    45,    42,    47,
      33,   319,    58,    59,   123,   125,    40,    61,    41,    44,
      91,    93
};
# endif

#define YYPACT_NINF -206

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-206)))

#define YYTABLE_NINF -146

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      -2,    13,    76,     9,   104,  -206,   115,     2,  -206,  -206,
    -206,     9,  -206,  -206,  -206,  -206,  -206,  -206,    18,     1,
     116,  -206,   127,    59,    58,  -206,  -206,  -206,    56,  -206,
    -206,    60,  -206,    68,    62,    67,    69,    70,   129,   116,
    -206,  -206,  -206,    77,  -206,   141,    78,  -206,    73,     4,
    -206,    60,  -206,    10,    10,    10,    10,  -206,  -206,   139,
      79,    51,     1,    74,  -206,  -206,    80,    82,  -206,  -206,
      85,   -45,  -206,  -206,  -206,    84,    84,  -206,    86,    93,
    1072,  -206,  -206,  -206,  -206,    90,  -206,  -206,  -206,  -206,
    -206,    95,    97,   101,   103,   107,   108,   109,   117,   118,
     119,   120,   121,   602,   602,   602,    89,  -206,  1435,  -206,
    -206,  -206,  -206,  -206,   113,   114,   123,   126,  -206,   602,
    -206,  -206,   -10,   124,  -206,  -206,   128,    15,    32,  -206,
    -206,    -1,   602,  -206,  -206,  -206,  -206,   130,   138,  -206,
     135,   140,   143,   144,   145,   199,  -206,  -206,  -206,  -206,
     208,  -206,    45,  -206,  -206,    -4,  -206,  -206,   602,   146,
      64,    64,   602,   195,   602,   204,   203,    92,   602,   176,
     177,  -206,  -206,  1040,    10,   602,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   157,   158,   159,
      10,  -206,  1073,   161,   156,  -206,   433,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,  -206,   363,   164,  1072,   165,  -206,
     602,   167,   602,   602,   602,   234,   173,   534,  -206,   174,
    -206,  -206,   602,    40,   179,  1183,  -206,  -206,  -206,   171,
    -206,   175,  1204,  -206,  -206,   178,  1095,   181,  -206,   182,
    -206,  -206,  -206,  -206,  -206,   183,  1117,   188,   189,  -206,
     191,  1446,  1456,    48,    48,    48,    48,    48,    48,    36,
      36,  -206,  -206,  -206,  -206,  -206,   192,   196,  -206,  -206,
     602,  -206,  -206,   172,  1435,  -206,  -206,   469,  -206,  1072,
    1372,   237,   179,  1225,  1246,  1267,   198,  -206,    47,  -206,
    -206,  1435,   201,    92,  1388,  -206,   602,   184,  -206,  -206,
    -206,  -206,  -206,   602,  -206,  -206,  -206,   602,  -206,   238,
     193,  1072,  1072,  1072,   207,    10,  1288,   602,   -57,  -206,
     133,  -206,  -206,   205,   210,   211,   213,  -206,  1072,   209,
     534,    10,    -6,  -206,  -206,  -206,  1435,  -206,  1139,  1309,
     212,  -206,   634,   657,   707,  -206,  -206,  -206,   515,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,   730,  -206,  -206,   219,
     215,  -206,   226,   602,  -206,  -206,  1072,  -206,  -206,  -206,
    1072,   602,   218,   259,  1072,  1072,   228,   229,  -206,   602,
    1330,   780,   803,  1161,  -206,   262,   259,  -206,   266,   853,
     876,  -206,  -206,  1404,  -206,  -206,  -206,  -206,   236,   235,
    -206,   602,   266,  -206,   270,  -206,  -206,   240,  -206,  1420,
     241,  -206,   233,   272,   270,  -206,  -206,  -206,  1072,   602,
     244,  -206,  -206,  1072,   926,  1351,  -206,   949,  -206,   248,
    1072,  -206,  -206,   999,  1072,  -206,  1022,  -206
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,    41,     0,     1,     0,     0,    19,    45,
       2,    42,    43,     4,    10,    27,    28,     8,     0,     0,
       0,    44,     0,     0,    12,     7,    29,    30,    20,    21,
      24,    71,    84,     0,     0,     0,     0,     0,     0,     3,
      46,    48,    49,     0,    11,     0,     0,    22,    31,     0,
      69,    71,    50,     0,     0,     0,     0,    60,    47,     0,
       0,     0,     0,     0,    25,    74,     0,     0,   137,   138,
       0,     0,    76,    78,    79,   188,   188,    75,     0,     0,
      92,   193,   192,   180,    67,     0,   184,   217,   183,   182,
     181,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   187,    68,   179,
     190,   191,   186,   185,     0,     0,     0,     0,     5,     0,
      17,    18,     0,     0,    23,    32,    33,     0,     0,    72,
      73,     0,     0,   139,   140,    86,    86,     0,     0,   121,
       0,     0,     0,    90,     0,     0,   115,   130,   131,   118,
       0,   117,    92,   116,   101,     0,   135,   119,     0,     0,
     206,     0,     0,   111,     0,   215,     0,     0,     0,     0,
       0,   164,   165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      63,     6,     0,     0,     0,    15,     0,    26,    34,    35,
      82,    83,    80,    81,    77,     0,     0,    92,     0,    98,
       0,   113,     0,     0,     0,     0,     0,     0,   133,     0,
      51,   102,     0,     0,   103,     0,   194,   214,   213,     0,
     207,     0,     0,   110,   112,     0,     0,     0,   216,     0,
     209,   210,   208,   212,   211,     0,     0,     0,     0,   163,
       0,   167,   166,   174,   177,   175,   176,   173,   172,   168,
     169,   170,   171,    58,    54,    56,     0,    64,    65,    13,
       0,     9,    16,     0,    36,   189,    70,    87,    85,    92,
       0,     0,   103,     0,     0,     0,     0,    88,     0,   106,
     109,   108,     0,     0,     0,   136,     0,     0,   178,   195,
     196,   197,   198,     0,   200,   201,   202,     0,   204,     0,
       0,    92,    92,    92,     0,     0,     0,     0,     0,    38,
      92,   123,   114,     0,     0,     0,     0,    91,    92,     0,
       0,    63,     0,    94,    96,   132,   104,   120,     0,     0,
       0,    52,    92,    92,    92,    61,    66,    14,     0,    37,
      39,    99,   122,   124,   128,   126,    92,   105,   107,     0,
       0,    95,     0,     0,   203,   205,    92,    59,    55,    57,
      92,     0,     0,   141,    92,    92,     0,     0,    93,     0,
       0,    92,    92,     0,   100,   151,   142,   143,     0,    92,
      92,    89,   134,     0,   199,    53,    62,    40,     0,     0,
     144,     0,   146,   148,   154,   127,    97,     0,   125,     0,
       0,   149,     0,   160,   155,   156,   152,   150,    92,     0,
       0,   129,   157,    92,    92,     0,   161,    92,   147,     0,
      92,   153,   158,    92,    92,   162,    92,   159
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -206,  -206,  -206,  -206,  -206,  -206,    19,  -206,  -206,  -206,
    -206,   202,  -206,  -206,  -206,  -206,   261,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,    12,  -206,  -206,   320,
    -206,   295,  -206,  -206,  -206,  -206,  -206,  -206,  -206,     5,
    -206,   -50,  -206,  -206,   284,  -206,  -206,   206,  -206,  -206,
    -206,  -206,   214,  -206,  -206,  -206,  -206,  -206,  -206,  -206,
       6,  -206,  -206,  -206,  -206,  -205,    57,  -206,  -206,    14,
     186,  -206,  -206,  -144,  -206,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,   -49,  -206,  -206,   -44,  -206,  -206,  -206,
     -56,  -206,  -206,  -206,  -206,   -69,  -206,  -206,  -206,   224,
     271,  -206,  -206,  -206,  -206,  -206,   185,   190,  -206,   -70
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    20,     3,    22,   191,   147,    24,    23,    46,
     122,   123,    18,    19,    28,    62,    29,    48,   126,    17,
      30,    64,   197,   198,   199,   318,   319,    10,    11,    12,
      39,    40,    80,   366,   312,   313,   311,   117,   370,   266,
     267,   268,    41,    78,    50,    70,    71,    72,    73,    74,
      42,    51,   206,   207,   148,   328,   216,   149,   150,   332,
     333,   362,   151,   279,   372,   152,   297,   153,   288,   289,
     290,   235,   282,   154,   224,   211,   373,   375,   374,   292,
     155,    75,    76,   107,   385,   386,   387,   388,   410,   402,
     403,   399,   423,   413,   414,   415,   434,   421,   430,   108,
     133,   109,   110,   111,   112,   229,   334,   230,   237,   113
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      77,     1,   277,   106,   114,   115,   116,   120,   221,   121,
     157,   240,   241,   242,   243,   244,    26,    15,   349,    81,
      82,    65,     9,   317,    83,    84,    85,    86,    87,    88,
       9,   156,   200,   130,   131,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   202,
      66,    67,    16,   137,     6,    66,    67,    27,     7,   138,
      68,    69,   139,    87,     8,   193,    68,    69,   120,   360,
     121,    68,    69,   222,   320,   223,     5,   103,   201,   203,
     104,   227,   157,   228,   140,     4,   105,   141,    68,    69,
       6,    25,   142,   143,     7,   238,    68,    69,   144,   145,
       8,    68,    69,   156,   185,   186,   342,   343,   344,   240,
     241,   242,   243,   244,   183,   184,   185,   186,   146,    13,
     220,    31,    32,   356,   250,   329,   330,    33,    34,    35,
      14,    43,    44,   221,    45,    47,    49,   157,    53,    36,
      37,   137,    52,    54,    57,    55,    56,   138,    60,    59,
     139,    87,    61,    63,   118,   125,   119,   127,   156,   128,
     135,   381,    38,   129,   132,   382,   158,   136,   174,   389,
     390,   159,   140,   160,   295,   141,   221,   161,     6,   162,
     142,   143,     7,   163,   164,   165,   144,   145,     8,    68,
      69,   187,   188,   166,   167,   168,   169,   170,   221,   221,
     221,   189,   190,   195,   209,   196,   146,   157,   351,   157,
     210,   212,   221,   424,   218,   219,   213,   233,   427,   214,
     215,   217,    87,   239,   226,   433,   247,   248,   156,   436,
     156,   263,   264,   265,   271,   272,   281,   221,   221,   276,
     278,   157,   157,   157,   286,   221,   221,   287,   293,   299,
     157,   296,   317,   300,   322,   340,   302,   337,   157,   304,
     305,   306,   156,   156,   156,   346,   308,   341,   309,   310,
     314,   156,   157,   157,   157,   315,   327,   331,   352,   156,
     221,   345,   357,   221,   353,   354,   157,   355,   378,   221,
     365,   384,   221,   156,   156,   156,   157,   377,   379,  -145,
     157,   391,   392,   398,   157,   157,   401,   156,   407,   419,
     408,   157,   157,   412,   416,   418,   420,   156,   426,   157,
     157,   156,   432,   124,   194,   156,   156,   171,   172,   173,
     350,    21,   156,   156,    58,    79,   359,   204,   361,   323,
     156,   156,   400,   192,   358,   422,   411,   134,   157,   234,
     208,   231,   245,   157,   157,     0,   205,   157,     0,     0,
     157,     0,     0,   157,   157,     0,   157,     0,     0,   156,
       0,     0,     0,     0,   156,   156,     0,     0,   156,     0,
       0,   156,   225,     0,   156,   156,   232,   156,   236,     0,
       0,     0,   246,     0,     0,     0,     0,     0,     0,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     274,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,     0,   280,     0,   283,   284,   285,     0,
       0,   291,    81,    82,   275,     0,   294,    83,     0,    85,
      86,    87,    88,     0,     0,     0,     0,     0,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,     0,     0,     0,     0,   -92,   137,     0,     0,
       0,     0,     0,   138,     0,     0,   139,    87,     0,    68,
      69,     0,     0,     0,   316,     0,     0,     0,     0,     0,
     103,     0,     0,   104,     0,     0,     0,   273,   140,   105,
       0,   141,     0,     0,     6,     0,   142,   143,     7,     0,
     336,     0,   144,   145,     8,    68,    69,   338,     0,     0,
       0,   339,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   348,   146,    81,    82,     0,     0,     0,    83,     0,
      85,    86,    87,    88,   291,     0,   233,     0,     0,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,     0,     0,   380,     0,     0,
      68,    69,     0,     0,     0,   383,   371,     0,     0,     0,
       0,   103,     0,   393,   104,     0,     0,     0,     0,     0,
     105,    81,    82,     0,     0,     0,    83,     0,    85,    86,
      87,    88,     0,     0,     0,   409,     0,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,     0,   137,   425,     0,     0,     0,     0,   138,     0,
       0,   139,    87,     0,     0,     0,     0,     0,    68,    69,
       0,     0,     0,     0,     0,   137,     0,     0,     0,   103,
       0,   138,   104,   140,   139,    87,   141,     0,   105,     6,
       0,   142,   143,     7,     0,     0,     0,   144,   145,     8,
      68,    69,     0,     0,     0,     0,   140,     0,     0,   141,
       0,     0,     6,     0,   142,   143,     7,   146,     0,   367,
     144,   145,     8,    68,    69,   137,     0,     0,     0,     0,
       0,   138,     0,     0,   139,    87,     0,     0,     0,     0,
     146,     0,   368,     0,     0,     0,     0,     0,   137,     0,
       0,     0,     0,     0,   138,     0,   140,   139,    87,   141,
       0,     0,     6,     0,   142,   143,     7,     0,     0,     0,
     144,   145,     8,    68,    69,     0,     0,     0,     0,   140,
       0,     0,   141,     0,     0,     6,     0,   142,   143,     7,
     146,     0,   369,   144,   145,     8,    68,    69,   137,     0,
       0,     0,     0,     0,   138,     0,     0,   139,    87,     0,
       0,     0,     0,   146,     0,   376,     0,     0,     0,     0,
       0,   137,     0,     0,     0,     0,     0,   138,     0,   140,
     139,    87,   141,     0,     0,     6,     0,   142,   143,     7,
       0,     0,     0,   144,   145,     8,    68,    69,     0,     0,
       0,     0,   140,     0,     0,   141,     0,     0,     6,     0,
     142,   143,     7,   146,     0,   395,   144,   145,     8,    68,
      69,   137,     0,     0,     0,     0,     0,   138,     0,     0,
     139,    87,     0,     0,     0,     0,   146,     0,   396,     0,
       0,     0,     0,     0,   137,     0,     0,     0,     0,     0,
     138,     0,   140,   139,    87,   141,     0,     0,     6,     0,
     142,   143,     7,     0,     0,     0,   144,   145,     8,    68,
      69,     0,     0,     0,     0,   140,     0,     0,   141,     0,
       0,     6,     0,   142,   143,     7,   146,     0,   404,   144,
     145,     8,    68,    69,   137,     0,     0,     0,     0,     0,
     138,     0,     0,   139,    87,     0,     0,     0,     0,   146,
       0,   405,     0,     0,     0,     0,     0,   137,     0,     0,
       0,     0,     0,   138,     0,   140,   139,    87,   141,     0,
       0,     6,     0,   142,   143,     7,     0,     0,     0,   144,
     145,     8,    68,    69,     0,     0,     0,     0,   140,     0,
       0,   141,     0,     0,     6,     0,   142,   143,     7,   146,
       0,   428,   144,   145,     8,    68,    69,   137,     0,     0,
       0,     0,     0,   138,     0,     0,   139,    87,     0,     0,
       0,     0,   146,     0,   431,     0,     0,     0,     0,     0,
     137,     0,     0,     0,     0,     0,   138,     0,   140,   139,
      87,   141,     0,     0,     6,     0,   142,   143,     7,     0,
       0,     0,   144,   145,     8,    68,    69,     0,     0,     0,
       0,   140,     0,     0,   141,     0,     0,     6,     0,   142,
     143,     7,   146,     0,   435,   144,   145,     8,    68,    69,
     137,     0,     0,     0,     0,     0,   138,     0,     0,   139,
      87,     0,     0,     0,     0,   146,     0,   437,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
       0,   140,     0,     0,   141,     0,     0,     6,   249,   142,
     143,     7,     0,     0,     0,   144,   145,     8,    68,    69,
       0,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,     0,     0,   146,     0,     0,     0,     0,
       0,   269,   270,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   303,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   307,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   363,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     397,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,     0,     0,     0,     0,     0,     0,     0,
       0,   298,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,     0,     0,
       0,     0,   301,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,     0,     0,     0,     0,     0,
       0,     0,     0,   324,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,     0,     0,     0,     0,
       0,     0,     0,     0,   325,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,     0,     0,     0,
       0,     0,     0,     0,     0,   326,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,     0,     0,     0,     0,   347,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,     0,
       0,     0,     0,     0,     0,     0,     0,   364,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,     0,     0,     0,     0,   394,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,     0,     0,     0,     0,     0,     0,     0,     0,   429,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,     0,     0,     0,   321,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,   335,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,   406,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,   417,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186
};

static const yytype_int16 yycheck[] =
{
      49,     3,   207,    53,    54,    55,    56,    17,   152,    19,
      80,    17,    18,    19,    20,    21,    15,    15,    75,     9,
      10,    17,     3,    80,    14,    15,    16,    17,    18,    19,
      11,    80,    17,    78,    79,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    17,
      51,    52,    50,     8,    45,    51,    52,    56,    49,    14,
      56,    57,    17,    18,    55,    75,    56,    57,    17,    75,
      19,    56,    57,    77,   279,    79,     0,    67,   127,   128,
      70,    17,   152,    19,    39,    72,    76,    42,    56,    57,
      45,    73,    47,    48,    49,   165,    56,    57,    53,    54,
      55,    56,    57,   152,    68,    69,   311,   312,   313,    17,
      18,    19,    20,    21,    66,    67,    68,    69,    73,    15,
      75,     5,     6,   328,   174,    78,    79,    11,    12,    13,
      15,     4,    73,   277,    76,    79,    76,   207,    76,    23,
      24,     8,    74,    76,    15,    76,    76,    14,     7,    72,
      17,    18,    74,    80,    15,    81,    77,    77,   207,    77,
      74,   366,    46,    78,    80,   370,    76,    74,    79,   374,
     375,    76,    39,    76,   223,    42,   320,    76,    45,    76,
      47,    48,    49,    76,    76,    76,    53,    54,    55,    56,
      57,    78,    78,    76,    76,    76,    76,    76,   342,   343,
     344,    78,    76,    79,    74,    77,    73,   277,    75,   279,
      72,    76,   356,   418,    15,     7,    76,    22,   423,    76,
      76,    76,    18,    20,    78,   430,    50,    50,   277,   434,
     279,    74,    74,    74,    73,    79,    69,   381,   382,    75,
      75,   311,   312,   313,    10,   389,   390,    74,    74,    78,
     320,    72,    80,    78,    17,    17,    78,    73,   328,    78,
      78,    78,   311,   312,   313,   315,    78,    74,    79,    78,
      78,   320,   342,   343,   344,    79,    78,    76,    73,   328,
     424,    74,    73,   427,    74,    74,   356,    74,    73,   433,
      78,    73,   436,   342,   343,   344,   366,    78,    72,    40,
     370,    73,    73,    41,   374,   375,    40,   356,    72,    76,
      75,   381,   382,    43,    74,    74,    44,   366,    74,   389,
     390,   370,    74,    62,   122,   374,   375,   103,   104,   105,
     318,    11,   381,   382,    39,    51,   331,   131,   332,   282,
     389,   390,   386,   119,   330,   414,   402,    76,   418,   163,
     136,   161,   167,   423,   424,    -1,   132,   427,    -1,    -1,
     430,    -1,    -1,   433,   434,    -1,   436,    -1,    -1,   418,
      -1,    -1,    -1,    -1,   423,   424,    -1,    -1,   427,    -1,
      -1,   430,   158,    -1,   433,   434,   162,   436,   164,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     196,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,   210,    -1,   212,   213,   214,    -1,
      -1,   217,     9,    10,    81,    -1,   222,    14,    -1,    16,
      17,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    -1,    -1,    -1,     7,     8,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    17,    18,    -1,    56,
      57,    -1,    -1,    -1,   270,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    70,    -1,    -1,    -1,    74,    39,    76,
      -1,    42,    -1,    -1,    45,    -1,    47,    48,    49,    -1,
     296,    -1,    53,    54,    55,    56,    57,   303,    -1,    -1,
      -1,   307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    73,     9,    10,    -1,    -1,    -1,    14,    -1,
      16,    17,    18,    19,   330,    -1,    22,    -1,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,   363,    -1,    -1,
      56,    57,    -1,    -1,    -1,   371,    81,    -1,    -1,    -1,
      -1,    67,    -1,   379,    70,    -1,    -1,    -1,    -1,    -1,
      76,     9,    10,    -1,    -1,    -1,    14,    -1,    16,    17,
      18,    19,    -1,    -1,    -1,   401,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,     8,   419,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    17,    18,    -1,    -1,    -1,    -1,    -1,    56,    57,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    67,
      -1,    14,    70,    39,    17,    18,    42,    -1,    76,    45,
      -1,    47,    48,    49,    -1,    -1,    -1,    53,    54,    55,
      56,    57,    -1,    -1,    -1,    -1,    39,    -1,    -1,    42,
      -1,    -1,    45,    -1,    47,    48,    49,    73,    -1,    75,
      53,    54,    55,    56,    57,     8,    -1,    -1,    -1,    -1,
      -1,    14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    39,    17,    18,    42,
      -1,    -1,    45,    -1,    47,    48,    49,    -1,    -1,    -1,
      53,    54,    55,    56,    57,    -1,    -1,    -1,    -1,    39,
      -1,    -1,    42,    -1,    -1,    45,    -1,    47,    48,    49,
      73,    -1,    75,    53,    54,    55,    56,    57,     8,    -1,
      -1,    -1,    -1,    -1,    14,    -1,    -1,    17,    18,    -1,
      -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    -1,    39,
      17,    18,    42,    -1,    -1,    45,    -1,    47,    48,    49,
      -1,    -1,    -1,    53,    54,    55,    56,    57,    -1,    -1,
      -1,    -1,    39,    -1,    -1,    42,    -1,    -1,    45,    -1,
      47,    48,    49,    73,    -1,    75,    53,    54,    55,    56,
      57,     8,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    39,    17,    18,    42,    -1,    -1,    45,    -1,
      47,    48,    49,    -1,    -1,    -1,    53,    54,    55,    56,
      57,    -1,    -1,    -1,    -1,    39,    -1,    -1,    42,    -1,
      -1,    45,    -1,    47,    48,    49,    73,    -1,    75,    53,
      54,    55,    56,    57,     8,    -1,    -1,    -1,    -1,    -1,
      14,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    73,
      -1,    75,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    39,    17,    18,    42,    -1,
      -1,    45,    -1,    47,    48,    49,    -1,    -1,    -1,    53,
      54,    55,    56,    57,    -1,    -1,    -1,    -1,    39,    -1,
      -1,    42,    -1,    -1,    45,    -1,    47,    48,    49,    73,
      -1,    75,    53,    54,    55,    56,    57,     8,    -1,    -1,
      -1,    -1,    -1,    14,    -1,    -1,    17,    18,    -1,    -1,
      -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,
       8,    -1,    -1,    -1,    -1,    -1,    14,    -1,    39,    17,
      18,    42,    -1,    -1,    45,    -1,    47,    48,    49,    -1,
      -1,    -1,    53,    54,    55,    56,    57,    -1,    -1,    -1,
      -1,    39,    -1,    -1,    42,    -1,    -1,    45,    -1,    47,
      48,    49,    73,    -1,    75,    53,    54,    55,    56,    57,
       8,    -1,    -1,    -1,    -1,    -1,    14,    -1,    -1,    17,
      18,    -1,    -1,    -1,    -1,    73,    -1,    75,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    39,    -1,    -1,    42,    -1,    -1,    45,    78,    47,
      48,    49,    -1,    -1,    -1,    53,    54,    55,    56,    57,
      -1,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    78,    79,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    78,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    78,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    78,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    78,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    78,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    78,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    78,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    -1,    -1,    -1,    73,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    -1,    -1,
      -1,    73,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    -1,    -1,    -1,    73,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      -1,    -1,    72,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    83,    85,    72,     0,    45,    49,    55,    88,
     109,   110,   111,    15,    15,    15,    50,   101,    94,    95,
      84,   111,    86,    90,    89,    73,    15,    56,    96,    98,
     102,     5,     6,    11,    12,    13,    23,    24,    46,   112,
     113,   124,   132,     4,    73,    76,    91,    79,    99,    76,
     126,   133,    74,    76,    76,    76,    76,    15,   113,    72,
       7,    74,    97,    80,   103,    17,    51,    52,    56,    57,
     127,   128,   129,   130,   131,   163,   164,   165,   125,   126,
     114,     9,    10,    14,    15,    16,    17,    18,    19,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    67,    70,    76,   123,   165,   181,   183,
     184,   185,   186,   191,   123,   123,   123,   119,    15,    77,
      17,    19,    92,    93,    98,    81,   100,    77,    77,    78,
      78,    79,    80,   182,   182,    74,    74,     8,    14,    17,
      39,    42,    47,    48,    53,    54,    73,    88,   136,   139,
     140,   144,   147,   149,   155,   162,   165,   191,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    76,    76,    76,
      76,   181,   181,   181,    79,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    78,    78,    78,
      76,    87,   181,    75,    93,    79,    77,   104,   105,   106,
      17,   165,    17,   165,   129,   181,   134,   135,   134,    74,
      72,   157,    76,    76,    76,    76,   138,    76,    15,     7,
      75,   155,    77,    79,   156,   181,    78,    17,    19,   187,
     189,   189,   181,    22,   152,   153,   181,   190,   191,    20,
      17,    18,    19,    20,    21,   188,   181,    50,    50,    78,
     123,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,    74,    74,    74,   121,   122,   123,    78,
      79,    73,    79,    74,   181,    81,    75,   147,    75,   145,
     181,    69,   154,   181,   181,   181,    10,    74,   150,   151,
     152,   181,   161,    74,   181,   165,    72,   148,    78,    78,
      78,    78,    78,    79,    78,    78,    78,    79,    78,    79,
      78,   118,   116,   117,    78,    79,   181,    80,   107,   108,
     147,    73,    17,   148,    78,    78,    78,    78,   137,    78,
      79,    76,   141,   142,   188,    73,   181,    73,   181,   181,
      17,    74,   147,   147,   147,    74,   123,    78,   181,    75,
     108,    75,    73,    74,    74,    74,   147,    73,   151,   121,
      75,   142,   143,    79,    78,    78,   115,    75,    75,    75,
     120,    81,   146,   158,   160,   159,    75,    78,    73,    72,
     181,   147,   147,   181,    73,   166,   167,   168,   169,   147,
     147,    73,    73,   181,    78,    75,    75,    79,    41,   173,
     168,    40,   171,   172,    75,    75,    73,    72,    75,   181,
     170,   172,    43,   175,   176,   177,    74,    72,    74,    76,
      44,   179,   177,   174,   147,   181,    74,   147,    75,    78,
     180,    75,    74,   147,   178,    75,   147,    75
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    82,    84,    83,    86,    87,    85,    88,    89,    88,
      90,    88,    91,    91,    91,    92,    92,    93,    93,    95,
      94,    96,    97,    96,    99,   100,    98,   101,   101,   102,
     102,   103,   103,   104,   104,   104,   105,   106,   107,   107,
     108,   109,   109,   110,   110,   111,   112,   112,   113,   113,
     114,   113,   115,   113,   116,   113,   117,   113,   118,   113,
     119,   120,   113,   121,   121,   122,   122,   123,   123,   125,
     124,   126,   126,   126,   127,   127,   128,   128,   129,   129,
     130,   130,   131,   131,   133,   132,   135,   134,   137,   136,
     138,   138,   140,   139,   141,   141,   143,   142,   145,   146,
     144,   147,   147,   148,   148,   149,   150,   150,   151,   151,
     152,   153,   153,   154,   154,   155,   155,   155,   155,   156,
     155,   157,   155,   155,   158,   155,   159,   155,   160,   155,
     155,   155,   155,   161,   155,   162,   162,   163,   164,   165,
     165,   166,   166,   167,   167,   169,   170,   168,   171,   171,
     172,   173,   174,   173,   175,   175,   176,   176,   178,   177,
     179,   180,   179,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   182,   182,
     183,   183,   184,   185,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   186,   186,   187,   187,   188,   188,
     188,   188,   188,   189,   189,   190,   190,   191
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     4,     0,     0,     8,     3,     0,     8,
       0,     4,     0,     5,     7,     2,     3,     1,     1,     0,
       2,     1,     0,     4,     0,     0,     5,     1,     1,     1,
       1,     0,     2,     0,     1,     1,     2,     4,     1,     2,
       5,     0,     1,     1,     2,     1,     1,     2,     1,     1,
       0,     5,     0,    10,     0,     8,     0,     8,     0,     8,
       0,     0,    10,     0,     1,     1,     3,     1,     1,     0,
       6,     0,     3,     3,     1,     1,     1,     3,     1,     1,
       3,     3,     3,     3,     0,     6,     0,     2,     0,     7,
       0,     3,     0,     6,     1,     2,     0,     5,     0,     0,
       7,     1,     2,     0,     2,     5,     1,     3,     1,     1,
       1,     0,     1,     0,     2,     1,     1,     1,     1,     0,
       4,     0,     5,     4,     0,     9,     0,     8,     0,    10,
       1,     1,     4,     0,     7,     1,     3,     1,     1,     2,
       2,     0,     1,     1,     2,     0,     0,     6,     1,     2,
       3,     0,     0,     6,     0,     1,     1,     2,     0,     8,
       0,     0,     5,     3,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       1,     1,     1,     1,     3,     4,     4,     4,     4,     8,
       4,     4,     4,     6,     4,     6,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 330 "parser.y" /* yacc.c:1646  */
    { utilOK = 1; }
#line 2110 "parser.c" /* yacc.c:1646  */
    break;

  case 3:
#line 331 "parser.y" /* yacc.c:1646  */
    {
              printf("-- populate our registries\n");
              printf("DestroDummies.registry.decideCombat[DestroDummies.class%s%s] = PickCombat;\n", classname, buildname);
              printf("DestroDummies.registry.decideNoCombat[DestroDummies.class%s%s] = PickNoCombat;\n", classname, buildname);
              printf("DestroDummies.lastMutexIndex = mIndexBase + %d;\n", mIndex);
          }
#line 2121 "parser.c" /* yacc.c:1646  */
    break;

  case 4:
#line 340 "parser.y" /* yacc.c:1646  */
    { classname = normalize(astrdup(yytext)); }
#line 2127 "parser.c" /* yacc.c:1646  */
    break;

  case 5:
#line 341 "parser.y" /* yacc.c:1646  */
    { buildname = normalize(astrdup(yytext)); }
#line 2133 "parser.c" /* yacc.c:1646  */
    break;

  case 6:
#line 342 "parser.y" /* yacc.c:1646  */
    {
              printf("-- Autogenerated file.  Do not edit.  All changes "
                                                        "will be lost\n");
              printf("--\n");
              printf("-- Definition of %s %s\n", buildname, classname);
              printf("\n");

              // set up the class variable
              printf("DestroDummies.class%s%s = DestroDummies.lastClassVal + 1;\n",
                     classname, buildname);
              printf("DestroDummies.lastClassVal = "
                                         "DestroDummies.lastClassVal + 1;\n");
              printf("\n");
              printf("local mIndexBase = DestroDummies.lastMutexIndex;\n");
              printf("\n");
          }
#line 2154 "parser.c" /* yacc.c:1646  */
    break;

  case 7:
#line 362 "parser.y" /* yacc.c:1646  */
    { printf(";\n"); }
#line 2160 "parser.c" /* yacc.c:1646  */
    break;

  case 8:
#line 364 "parser.y" /* yacc.c:1646  */
    {
              curvar = amalloc(200);
              sprintf(curvar,
                      "DestroDummies.mutex[mIndexBase + %d]",
                      ++mIndex);
              lex_register_mutex(yytext, mIndex);
              indent(0);
              printf("%s = {};\n", curvar);
              cur_mutexno = 0;
          }
#line 2175 "parser.c" /* yacc.c:1646  */
    break;

  case 9:
#line 375 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("%s.count = %d;\n", curvar, cur_mutexno);
          }
#line 2184 "parser.c" /* yacc.c:1646  */
    break;

  case 10:
#line 379 "parser.y" /* yacc.c:1646  */
    { lex_register_variable(yytext, T_EXTERNVARIABLE); }
#line 2190 "parser.c" /* yacc.c:1646  */
    break;

  case 12:
#line 385 "parser.y" /* yacc.c:1646  */
    {
                indent(0);
                printf("%s.clipCombat = 0;\n", curvar);
                printf("%s.clipOOCombat = 0;\n", curvar);
            }
#line 2200 "parser.c" /* yacc.c:1646  */
    break;

  case 13:
#line 391 "parser.y" /* yacc.c:1646  */
    {
                indent(0);
                printf("%s.clipCombat = %s;\n", curvar, (yyvsp[-1]).str);
                printf("%s.clipOOCombat = %s;\n", curvar, (yyvsp[-1]).str);
            }
#line 2210 "parser.c" /* yacc.c:1646  */
    break;

  case 14:
#line 397 "parser.y" /* yacc.c:1646  */
    {
                indent(0);
                printf("%s.clipOOCombat = %s;\n", curvar, (yyvsp[-3]).str);
                printf("%s.clipCombat = %s;\n", curvar, (yyvsp[-1]).str);
            }
#line 2220 "parser.c" /* yacc.c:1646  */
    break;

  case 17:
#line 412 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("%s[%d] = %d;\n",
                     curvar, ++cur_mutexno, (yyvsp[0]).thing.index);
          }
#line 2230 "parser.c" /* yacc.c:1646  */
    break;

  case 18:
#line 418 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("%s[%d] = %d;\n",
                     curvar, ++cur_mutexno, (yyvsp[0]).thing.index);
          }
#line 2240 "parser.c" /* yacc.c:1646  */
    break;

  case 19:
#line 428 "parser.y" /* yacc.c:1646  */
    { indent(0); printf("local "); }
#line 2246 "parser.c" /* yacc.c:1646  */
    break;

  case 22:
#line 433 "parser.y" /* yacc.c:1646  */
    { printf(", "); }
#line 2252 "parser.c" /* yacc.c:1646  */
    break;

  case 24:
#line 439 "parser.y" /* yacc.c:1646  */
    {
              // note that something very similar is done at the
              // parameter production.  these ought to be unified, but
              // for now, just note that any changes here probably have
              // to be made there too
              curvar = amalloc(strlen(yytext) + 4);
              sprintf(curvar, "var%s", yytext);
              lex_register_variable(yytext, T_VARIABLE);
          }
#line 2266 "parser.c" /* yacc.c:1646  */
    break;

  case 25:
#line 449 "parser.y" /* yacc.c:1646  */
    {
              curvar_array = (yyvsp[0]).intg;
              if (curvar_array) {
                  indent(0);
                  printf("%s = {};\n", curvar);
              }
          }
#line 2278 "parser.c" /* yacc.c:1646  */
    break;

  case 26:
#line 457 "parser.y" /* yacc.c:1646  */
    {
              if (!curvar_array) {
                  printf("%s", curvar);
                  if ((yyvsp[0]).str != NULL) {
                      printf(" = %s", (yyvsp[0]).str);
                      free((yyvsp[0]).str);
                  }
              }
              free(curvar);
              curvar = NULL;
          }
#line 2294 "parser.c" /* yacc.c:1646  */
    break;

  case 31:
#line 482 "parser.y" /* yacc.c:1646  */
    { (yyval).intg = 0; }
#line 2300 "parser.c" /* yacc.c:1646  */
    break;

  case 32:
#line 483 "parser.y" /* yacc.c:1646  */
    { (yyval).intg = 1; }
#line 2306 "parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 487 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 2312 "parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 488 "parser.y" /* yacc.c:1646  */
    { (yyval).str = (yyvsp[0]).str; }
#line 2318 "parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 489 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 2324 "parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 495 "parser.y" /* yacc.c:1646  */
    {
              if (curvar_array) {
                  fprintf(stderr, "%s:%d: Error: %s is an array, cannot "
                          "single init it.\n", filename, lineno, curvar);
                  exit(1);
              }
              (yyval) = (yyvsp[0]);
          }
#line 2337 "parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 519 "parser.y" /* yacc.c:1646  */
    {
              if (!curvar_array) {
                  fprintf(stderr, "%s:%d: Error: %s is not an array.  Cannot aggregate init it.\n", filename, lineno, curvar);
                  exit(1);
              }
              printf("%s[%s] = %s;\n", curvar, (yyvsp[-3]).str, (yyvsp[-1]).str);
              free((yyvsp[-3]).str);
              free((yyvsp[-1]).str);
          }
#line 2351 "parser.c" /* yacc.c:1646  */
    break;

  case 50:
#line 558 "parser.y" /* yacc.c:1646  */
    {
                printf("\nlocal function preCombat()\n");
                indent_level++;
            }
#line 2360 "parser.c" /* yacc.c:1646  */
    break;

  case 51:
#line 563 "parser.y" /* yacc.c:1646  */
    {
                indent_level--;
                printf("end\n");
                printf("DestroDummies.registry.preCombat[DestroDummies.class%s%s] = preCombat;\n\n", classname, buildname);
            }
#line 2370 "parser.c" /* yacc.c:1646  */
    break;

  case 52:
#line 569 "parser.y" /* yacc.c:1646  */
    {
                // called with parameters:
                //     first:  spell name
                //     second: true if spell succeeded
                printf("\nlocal function postSpell(%s, %s)\n", (yyvsp[-4]).str, (yyvsp[-2]).str);
                free((yyvsp[-4]).str);
                free((yyvsp[-2]).str);
                indent_level++;
            }
#line 2384 "parser.c" /* yacc.c:1646  */
    break;

  case 53:
#line 579 "parser.y" /* yacc.c:1646  */
    {
                indent_level--;
                printf("end\n");
                printf("DestroDummies.registry.postSpell[DestroDummies.class%s%s] = postSpell;\n\n", classname, buildname);
            }
#line 2394 "parser.c" /* yacc.c:1646  */
    break;

  case 54:
#line 585 "parser.y" /* yacc.c:1646  */
    {
                printf("\nlocal function takeDamage(%s)\n", (yyvsp[-2]).str);
                free((yyvsp[-2]).str);
                indent_level++;
            }
#line 2404 "parser.c" /* yacc.c:1646  */
    break;

  case 55:
#line 591 "parser.y" /* yacc.c:1646  */
    {
                indent_level--;
                printf("end\n");
                printf("DestroDummies.registry.takeDamage[DestroDummies.class%s%s] = takeDamage;\n\n", classname, buildname);
            }
#line 2414 "parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 598 "parser.y" /* yacc.c:1646  */
    {
                printf("\nlocal function takeHeal(%s)\n", (yyvsp[-2]).str);
                free((yyvsp[-2]).str);
                indent_level++;
            }
#line 2424 "parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 604 "parser.y" /* yacc.c:1646  */
    {
                indent_level--;
                printf("end\n");
                printf("DestroDummies.registry.takeHeal[DestroDummies.class%s%s] = takeHeal;\n\n", classname, buildname);
            }
#line 2434 "parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 611 "parser.y" /* yacc.c:1646  */
    {
                printf("\nlocal function spellSent(%s)\n", (yyvsp[-2]).str);
                free((yyvsp[-2]).str);
                indent_level++;
            }
#line 2444 "parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 617 "parser.y" /* yacc.c:1646  */
    {
                indent_level--;
                printf("end\n");
                printf("DestroDummies.registry.spellSent[DestroDummies.class%s%s] = spellSent;\n\n", classname, buildname);
            }
#line 2454 "parser.c" /* yacc.c:1646  */
    break;

  case 60:
#line 623 "parser.y" /* yacc.c:1646  */
    { (yyval).str = strdup(yytext); }
#line 2460 "parser.c" /* yacc.c:1646  */
    break;

  case 61:
#line 625 "parser.y" /* yacc.c:1646  */
    {
                printf("\nfunction DestroDummies:genfunc_%s(%s)\n",
                       (yyvsp[-4]).str, (yyvsp[-2]).str);
                free((yyvsp[-4]).str);
                free((yyvsp[-2]).str);
                indent_level++;

                (yyval).intg = utilOK;
                utilOK = 1;     // this will be called from where it's ok
            }
#line 2475 "parser.c" /* yacc.c:1646  */
    break;

  case 62:
#line 636 "parser.y" /* yacc.c:1646  */
    {
                utilOK = (yyvsp[-2]).intg;
                indent_level--;
                printf("end\n\n");
            }
#line 2485 "parser.c" /* yacc.c:1646  */
    break;

  case 63:
#line 645 "parser.y" /* yacc.c:1646  */
    { (yyval).str = strdup(""); }
#line 2491 "parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 653 "parser.y" /* yacc.c:1646  */
    {
                (yyval).str = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 3);
                sprintf((yyval).str, "%s, %s", (yyvsp[-2]).str, (yyvsp[0]).str);
                free((yyvsp[-2]).str);
                free((yyvsp[0]).str);
            }
#line 2502 "parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 664 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = amalloc(strlen(yytext) + 4);
              sprintf((yyval).str, "var%s", yytext);
              lex_register_variable(yytext, T_VARIABLE);
          }
#line 2512 "parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 674 "parser.y" /* yacc.c:1646  */
    {
              if (have_incombat) {
                  fprintf(stderr, "%s:%d Error: Multiple incombat routines\n",
                          filename, lineno);
                  exit(1);
              }
              have_incombat = true;
              printf("local function PickCombat()\n");
              indent_level++;
          }
#line 2527 "parser.c" /* yacc.c:1646  */
    break;

  case 70:
#line 685 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("return DestroDummies:analysisPick(%s, %s);\n",
                     fail_spell == NULL ? "nil" : fail_spell,
                     free_spell == NULL ? "nil" : free_spell);
              free(fail_spell);
              fail_spell = NULL;
              free(free_spell);
              free_spell = NULL;
              indent_level--;
              indent(0);
              printf("end\n\n");
          }
#line 2545 "parser.c" /* yacc.c:1646  */
    break;

  case 72:
#line 704 "parser.y" /* yacc.c:1646  */
    {
                if (fail_spell != NULL) {
                    fprintf(stderr, "%s:%d: too many fail cases\n",
                            filename, lineno);
                    exit(1);
                }
                fail_spell = (yyvsp[-1]).str;
            }
#line 2558 "parser.c" /* yacc.c:1646  */
    break;

  case 74:
#line 717 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup(yytext); }
#line 2564 "parser.c" /* yacc.c:1646  */
    break;

  case 78:
#line 729 "parser.y" /* yacc.c:1646  */
    {
                if (fail_spell != NULL) {
                    fprintf(stderr, "%s:%d: too many fail cases\n", filename,
                            lineno);
                    exit(1);
                }
                fail_spell = (yyvsp[0]).str;
            }
#line 2577 "parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 738 "parser.y" /* yacc.c:1646  */
    {
                if (free_spell != NULL) {
                    /*
                     *  There's no reason not to allow more than one and
                     *  rotate through, but I don't think there will ever
                     *  be a desire, so I'm just implementing it easy now
                     */
                    fprintf(stderr, "%s:%d: too many free cases\n", filename,
                            lineno);
                    exit(1);
                }
                free_spell = (yyvsp[0]).str;
            }
#line 2595 "parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 755 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 2601 "parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 756 "parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2607 "parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 761 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 2613 "parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 762 "parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2619 "parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 767 "parser.y" /* yacc.c:1646  */
    {
              if (have_oocombat) {
                  fprintf(stderr, "%s:%d Error: Multiple oocombat routines\n",
                          filename, lineno);
                  exit(1);
              }
              have_oocombat = true;
              printf("local function PickNoCombat()\n");
              indent_level++;
          }
#line 2634 "parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 779 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("return DestroDummies:analysisPick(%s, %s);\n",
                     // people (me) might set the fail or free spell to nil
                     // instead of 0, so we correct for that
                     fail_spell == NULL || !strcmp(fail_spell, "nil")
                     ? "0" : fail_spell,
                     free_spell == NULL || !strcmp(free_spell, "nil")
                     ? "0" : free_spell);
              if (fail_spell != NULL)
                  free(fail_spell);
              fail_spell = NULL;
              if (free_spell != NULL)
                  free(free_spell);
              free_spell = NULL;

              indent_level--;
              indent(0);
              printf("end\n\n");
          }
#line 2659 "parser.c" /* yacc.c:1646  */
    break;

  case 86:
#line 804 "parser.y" /* yacc.c:1646  */
    { indent(0); printf("DestroDummies:analysisInit();\n"); }
#line 2665 "parser.c" /* yacc.c:1646  */
    break;

  case 88:
#line 811 "parser.y" /* yacc.c:1646  */
    { rotMode = RM_ALTERNATE; }
#line 2671 "parser.c" /* yacc.c:1646  */
    break;

  case 89:
#line 813 "parser.y" /* yacc.c:1646  */
    { rotMode = RM_NORMAL; }
#line 2677 "parser.c" /* yacc.c:1646  */
    break;

  case 90:
#line 818 "parser.y" /* yacc.c:1646  */
    { altnum = 0; }
#line 2683 "parser.c" /* yacc.c:1646  */
    break;

  case 91:
#line 819 "parser.y" /* yacc.c:1646  */
    { altnum = (yyvsp[-1]).intg; }
#line 2689 "parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 823 "parser.y" /* yacc.c:1646  */
    { printf("\n"); }
#line 2695 "parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 823 "parser.y" /* yacc.c:1646  */
    { printf("\n"); }
#line 2701 "parser.c" /* yacc.c:1646  */
    break;

  case 96:
#line 832 "parser.y" /* yacc.c:1646  */
    {
              char *clip;
              int aura;

              aura = make_aura(&(yyvsp[0]).thing);
              clip = aura2clip(aura);
              have_clip(aura, clip);
              indent(0);
              printf("local %s = ", clip);
          }
#line 2716 "parser.c" /* yacc.c:1646  */
    break;

  case 97:
#line 843 "parser.y" /* yacc.c:1646  */
    {
              printf("%s;\n", (yyvsp[-1]).str);
              free((yyvsp[-1]).str);
          }
#line 2725 "parser.c" /* yacc.c:1646  */
    break;

  case 98:
#line 851 "parser.y" /* yacc.c:1646  */
    { rotMode = RM_STRICT; }
#line 2731 "parser.c" /* yacc.c:1646  */
    break;

  case 99:
#line 853 "parser.y" /* yacc.c:1646  */
    { rotMode = RM_NORMAL; }
#line 2737 "parser.c" /* yacc.c:1646  */
    break;

  case 103:
#line 864 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 2743 "parser.c" /* yacc.c:1646  */
    break;

  case 104:
#line 865 "parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 2749 "parser.c" /* yacc.c:1646  */
    break;

  case 105:
#line 871 "parser.y" /* yacc.c:1646  */
    {
                indent(0);
                printf("print(%s);\n", (yyvsp[-2]).str);
                free((yyvsp[-2]).str);
            }
#line 2759 "parser.c" /* yacc.c:1646  */
    break;

  case 107:
#line 882 "parser.y" /* yacc.c:1646  */
    {
                (yyval).str = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 3);
                sprintf((yyval).str, "%s, %s", (yyvsp[-2]).str, (yyvsp[0]).str);
                free((yyvsp[-2]).str);
                free((yyvsp[0]).str);
            }
#line 2770 "parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 898 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup(yytext); }
#line 2776 "parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 902 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 2782 "parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 915 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 2788 "parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 916 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 2794 "parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 926 "parser.y" /* yacc.c:1646  */
    { cur_thing = (yyvsp[0]).thing;}
#line 2800 "parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 928 "parser.y" /* yacc.c:1646  */
    {
                if ((yyvsp[-1]).str != NULL) {
                    indent(0);
                    printf("if (%s) then\n", (yyvsp[-1]).str);
                    indent_level++;
                }

                indent(0);
                // For now, we require all items to be off cooldown
                // (to prevent the out-of-combat nags to use something
                // on a long cooldown).  In the future, we might want
                // to be more clever.
                printf("DestroDummies:analysisAddItem(%d, true, \"%s\", %d); -- %s\n",
                       (yyvsp[-3]).thing.index, basename(filename), lineno,
                       (yyvsp[-3]).thing.name);

                if ((yyvsp[-1]).str != NULL) {
                    indent_level--;
                    indent(0);
                    printf("end\n");
                    free((yyvsp[-1]).str);
                }
                bzero(&cur_thing, sizeof(cur_thing));
            }
#line 2829 "parser.c" /* yacc.c:1646  */
    break;

  case 121:
#line 953 "parser.y" /* yacc.c:1646  */
    { cur_thing = (yyvsp[0]).thing; }
#line 2835 "parser.c" /* yacc.c:1646  */
    break;

  case 122:
#line 955 "parser.y" /* yacc.c:1646  */
    {
                if ((yyvsp[-1]).str != NULL) {
                    indent(0);
                    printf("if (%s) then\n", (yyvsp[-1]).str);
                    indent_level++;
                }
                switch (rotMode) {
                case RM_NORMAL:
                    if (debugging) {
                        indent(0);
                        printf("if DestroDummies.debug then\n");
                        indent(1);
                        printf("print(\"Analysis Add \", %d", cur_thing.index);
                        if ((yyvsp[-2]).str != NULL)
                            printf(", %s", (yyvsp[-2]).str);
                        printf("); -- %s\n", cur_thing.name);
                        indent(0);
                        printf("end\n");
                    }
                    indent(0);
                    printf("DestroDummies:analysisAdd(%d", cur_thing.index);
                    if ((yyvsp[-2]).str != NULL)
                        printf(", %s", (yyvsp[-2]).str);
                    else
                        printf(", nil");
                    printf(", \"%s\", %d); -- %s\n",
                           basename(filename), lineno, cur_thing.name);
                    break;

                case RM_STRICT:
                    if ((yyvsp[-2]).str != NULL) {
                        fprintf(stderr,
                                "Cannot have a spell mintime with strict\n");
                        exit(1);
                    }
                    indent(0);
                    printf("return %d; -- %s\n",
                           cur_thing.index, cur_thing.name);
                    break;

                case RM_ALTERNATE:
                    if ((yyvsp[-2]).str != NULL) {
                        fprintf(stderr,
                                "Cannot have a spell mintime with strict\n");
                        exit(1);
                    }
                    indent(0);
                    printf("DestroDummies:altRecommend(%d, %d); -- %s\n",
                           cur_thing.index, altnum, cur_thing.name);
                    break;

                default:
                    fprintf(stderr, "Unknown rotMode: %d\n", rotMode);
                    exit(1);
                }
                if ((yyvsp[-2]).str != NULL)
                    free((yyvsp[-2]).str);
                if ((yyvsp[-1]).str != NULL) {
                    indent_level--;
                    indent(0);
                    printf("end\n");
                    free((yyvsp[-1]).str);
                }
                bzero(&cur_thing, sizeof(cur_thing));
            }
#line 2905 "parser.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1021 "parser.y" /* yacc.c:1646  */
    {
                if (rotMode != RM_STRICT) {
                    fprintf(stderr, "%d: nil only makes sense in a strict\n",
                            lineno);
                    exit(1);
                }
                indent(0);
                printf("if (%s) then\n", (yyvsp[-1]).str);
                indent(1);
                printf("return nil;\n");
                indent(0);
                printf("end\n");
                free((yyvsp[-1]).str);
            }
#line 2924 "parser.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1036 "parser.y" /* yacc.c:1646  */
    {
                /*
                 *  This is pretty ugly.  Because of nested switch statements
                 *  we save off the one we are currently processing and
                 *  replace with our own (so our cases refer to the right
                 *  variable), and then restore when we are done with our
                 *  switch.  This is cleaner than using $-2.intg or some
                 *  such YACC trick.
                 */
                int count = switchcount++;

                if (count > MAX_SWITCH_COUNT) {
                    fprintf(stderr, "Too many switches (%d max)\n",
                            MAX_SWITCH_COUNT);
                    exit(1);
                }
                (yyval).intg = cur_switchnum;
                cur_switchnum = count;
                seen_case[count] = 0;

                indent(0);
                printf("local switchvar%d = %s;\n", count, (yyvsp[-2]).str);
                free((yyvsp[-2]).str);
            }
#line 2953 "parser.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1061 "parser.y" /* yacc.c:1646  */
    {
                cur_switchnum = (yyvsp[-3]).intg;
                indent(0);
                printf("end\n");
            }
#line 2963 "parser.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1067 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("while %s do\n", (yyvsp[-2]).str);
              free((yyvsp[-2]).str);
              indent_level++;
          }
#line 2974 "parser.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1074 "parser.y" /* yacc.c:1646  */
    {
              indent_level--;
              indent(0);
              printf("end\n");
          }
#line 2984 "parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1081 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("if %s then\n", (yyvsp[-2]).str);
              free((yyvsp[-2]).str);
              indent_level++;
          }
#line 2995 "parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1088 "parser.y" /* yacc.c:1646  */
    {
              indent_level--;
              indent(0);
              printf("end\n");
          }
#line 3005 "parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1096 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("%s = %s;\n", (yyvsp[-3]).str, (yyvsp[-1]).str);
              free((yyvsp[-3]).str);
              free((yyvsp[-1]).str);
          }
#line 3016 "parser.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1103 "parser.y" /* yacc.c:1646  */
    { (yyval).str = strdup(yytext); }
#line 3022 "parser.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1105 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("DestroDummies:genfunc_%s(%s);\n", (yyvsp[-4]).str, (yyvsp[-2]).str);
              free((yyvsp[-4]).str);
              free((yyvsp[-2]).str);
          }
#line 3033 "parser.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1114 "parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); }
#line 3039 "parser.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1116 "parser.y" /* yacc.c:1646  */
    {
                (yyval).str = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 3);
                sprintf((yyval).str, "%s, %s", (yyvsp[-2]).str, (yyvsp[0]).str);
                free((yyvsp[-2]).str);
                free((yyvsp[0]).str);
            }
#line 3050 "parser.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1127 "parser.y" /* yacc.c:1646  */
    {
                (yyval).str = amalloc(strlen(yytext) + 4);
                sprintf((yyval).str, "var%s", yytext);
            }
#line 3059 "parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1135 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup(yytext); }
#line 3065 "parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1140 "parser.y" /* yacc.c:1646  */
    {
              if ((yyvsp[0]).str != NULL) {
                  (yyval).str = amalloc(strlen((yyvsp[-1]).str) + strlen((yyvsp[0]).str) + 3);
                  sprintf((yyval).str, "%s[%s]", (yyvsp[-1]).str, (yyvsp[0]).str);
                  free((yyvsp[-1]).str);
                  free((yyvsp[0]).str);
              } else
                  (yyval) = (yyvsp[-1]);
          }
#line 3079 "parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1150 "parser.y" /* yacc.c:1646  */
    {
              if ((yyvsp[0]).str != NULL) {
                  (yyval).str = amalloc(strlen((yyvsp[-1]).str) + strlen((yyvsp[0]).str) + 3);
                  sprintf((yyval).str, "%s[%s]", (yyvsp[-1]).str, (yyvsp[0]).str);
                  free((yyvsp[-1]).str);
                  free((yyvsp[0]).str);
              } else
                  (yyval) = (yyvsp[-1]);
          }
#line 3093 "parser.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1174 "parser.y" /* yacc.c:1646  */
    { seen_a_case = 0; }
#line 3099 "parser.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1176 "parser.y" /* yacc.c:1646  */
    { printf(") then\n"); }
#line 3105 "parser.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1178 "parser.y" /* yacc.c:1646  */
    { indent_level--; }
#line 3111 "parser.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1189 "parser.y" /* yacc.c:1646  */
    {
              if (!seen_a_case) {
                  indent(0);
                  printf("%s ((switchvar%d == (%s)) ",
                           seen_case[cur_switchnum] ? "elseif" : "if",
                           cur_switchnum, (yyvsp[-1]).str);
                  seen_case[cur_switchnum] = 1;
                  indent_level++;
                  seen_a_case = 1;
              } else
                  printf("or (switchvar%d == (%s))", cur_switchnum, (yyvsp[-1]).str);
          }
#line 3128 "parser.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1207 "parser.y" /* yacc.c:1646  */
    {
              indent(0);
              printf("else\n");
              indent_level++;
          }
#line 3138 "parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1213 "parser.y" /* yacc.c:1646  */
    { indent_level--; }
#line 3144 "parser.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1228 "parser.y" /* yacc.c:1646  */
    {
              indent(-1);
              printf("elseif (%s) then\n", (yyvsp[-2]).str);
              free((yyvsp[-2]).str);
          }
#line 3154 "parser.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1239 "parser.y" /* yacc.c:1646  */
    {
              indent(-1);
              printf("else\n");
          }
#line 3163 "parser.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1248 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-1]).str) + 3);
              sprintf(newstr, "(%s)", (yyvsp[-1]).str);
              free((yyvsp[-1]).str);
              (yyval).str = newstr;
          }
#line 3176 "parser.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1257 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "- (%s)", (yyvsp[0]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3189 "parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1266 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "not (%s)", (yyvsp[0]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3202 "parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1275 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) and (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3216 "parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1285 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) or (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3230 "parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1295 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) + (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3244 "parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1305 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) - (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3258 "parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1315 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) * (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3272 "parser.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1325 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) / (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3286 "parser.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1335 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) > (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3300 "parser.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1345 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) < (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3314 "parser.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1355 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) >= (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3328 "parser.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1365 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) <= (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3342 "parser.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1375 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) == (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3356 "parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1385 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(strlen((yyvsp[-2]).str) + strlen((yyvsp[0]).str) + 250);
              sprintf(newstr, "(%s) ~= (%s)", (yyvsp[-2]).str, (yyvsp[0]).str);
              free((yyvsp[-2]).str);
              free((yyvsp[0]).str);
              (yyval).str = newstr;
          }
#line 3370 "parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1395 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;
              newstr = amalloc(strlen((yyvsp[-1]).str) + 250);
              sprintf(newstr, "math.abs(%s)", (yyvsp[-1]).str);
              free((yyvsp[-1]).str);
              (yyval).str = newstr;
          }
#line 3382 "parser.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1403 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup("nil"); }
#line 3388 "parser.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1404 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup("nil"); }
#line 3394 "parser.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1405 "parser.y" /* yacc.c:1646  */
    { (yyval).str = astrdup("true"); }
#line 3400 "parser.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1406 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 3406 "parser.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1407 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 3412 "parser.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1408 "parser.y" /* yacc.c:1646  */
    { (yyval).str = intstring((yyvsp[0]).thing.index); }
#line 3418 "parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1415 "parser.y" /* yacc.c:1646  */
    { (yyval).str = NULL; }
#line 3424 "parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1416 "parser.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); }
#line 3430 "parser.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1426 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(250);
              sprintf(newstr, "%d", (yyvsp[0]).intg);
              (yyval).str = newstr;
          }
#line 3442 "parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1437 "parser.y" /* yacc.c:1646  */
    {
              char *newstr;

              newstr = amalloc(250);
              sprintf(newstr, "%0.2lf", (yyvsp[0]).fl);
              (yyval).str = newstr;
          }
#line 3454 "parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1449 "parser.y" /* yacc.c:1646  */
    { (yyval).str = proc_builtin1((yyvsp[-2]).bi); }
#line 3460 "parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1451 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin2((yyvsp[-3]).bi, &(yyvsp[-1]).thing);
          }
#line 3468 "parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1455 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin2((yyvsp[-3]).bi, &(yyvsp[-1]).thing);
          }
#line 3476 "parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1459 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin3((yyvsp[-3]).bi, (yyvsp[-1]).str);
              free((yyvsp[-1]).str);
          }
#line 3485 "parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1464 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin4((yyvsp[-3]).bi, (yyvsp[-1]).str);
              free((yyvsp[-1]).str);
          }
#line 3494 "parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1469 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin5((yyvsp[-7]).bi, (yyvsp[-5]).str, (yyvsp[-3]).str, (yyvsp[-1]).str);
              free((yyvsp[-5]).str);
              free((yyvsp[-3]).str);
              free((yyvsp[-1]).str);
          }
#line 3505 "parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1476 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin6((yyvsp[-3]).bi, &(yyvsp[-1]).thing);
          }
#line 3513 "parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1480 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin7((yyvsp[-3]).bi, (yyvsp[-1]).thing.index);
          }
#line 3521 "parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1484 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin8((yyvsp[-3]).bi, &(yyvsp[-1]).thing);
          }
#line 3529 "parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1488 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin9((yyvsp[-5]).bi, (yyvsp[-3]).str, (yyvsp[-1]).str);
          }
#line 3537 "parser.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1492 "parser.y" /* yacc.c:1646  */
    { (yyval).str = proc_builtin_mx((yyvsp[-3]).bi, (yyvsp[-1]).intg); }
#line 3543 "parser.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1494 "parser.y" /* yacc.c:1646  */
    {
              (yyval).str = proc_builtin_mx2((yyvsp[-5]).bi, (yyvsp[-3]).intg,
                                        intstring((yyvsp[-1]).thing.index));
              free((yyvsp[-1]).str);
          }
#line 3553 "parser.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1504 "parser.y" /* yacc.c:1646  */
    {
              if (cur_thing.index == 0) {
                  /*
                   *  Better than a SEGV, though it should never happen
                   *
                   *  Actually, this can happen (and has) in a bizarre
                   *  circumstance which is a pain in the ass to figure out.
                   *  If you are referring to a spell outside the normal
                   *  combat/nocombat routines (say, in the postspell
                   *  handler), and the spell doesn't exist in strings.c,
                   *  you will end up here (because the spell is returned
                   *  as T_STRING instead of T_SPELL).
                   */
                  fprintf(stderr, "%s:%d: cur_thing set to 0???\n",
                          filename, lineno);
                  fprintf(stderr, "Perhaps the spell is not in strings.c?\n");
                  exit(1);
              }
              (yyval).thing = cur_thing;
          }
#line 3578 "parser.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1543 "parser.y" /* yacc.c:1646  */
    { (yyval).thing = cur_thing; }
#line 3584 "parser.c" /* yacc.c:1646  */
    break;


#line 3588 "parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1550 "parser.y" /* yacc.c:1906  */


// the cost for known spells
static int
wow_cost (const int spell)
{
    static struct {
        char *name;
        int spell;      // spell number
        int cost;
    } map[] = {
        { "Explosive Shot",     0, 15 },
        { "Black Arrow",        0, 35 },
        { "Arcane Shot",        0, 30 },
        { "A Murder of Crows",  0, 30 },
        { "Stampede",           0,  0 },   // not sure
        { "Glaive Toss",        0, 15 },
        { "Barrage",            0, 60 },
    };
    int i;
    static bool first = true;

    if (first) {
        for (i = 0 ; i < NELEM(map) ; i++)
            map[i].spell = thing_number(TH_SPELL, map[i].name);
        first = false;
    }

    for (i = 0 ; i < NELEM(map) ; i++) {
        if (map[i].spell == spell)
            return map[i].cost;
    }

    fprintf(stderr, "%s:%d: Unknown cost for spell \"%d\"\n",
            filename, lineno, spell);
    exit(1);
}

static void
indent (int extra)
{
    int i;

    for (i = 0 ; i < 4 * (indent_level + extra) ; i++)
        putchar(' ');
}

int
main (int argc, char *argv[])
{
    int c;
    int lflg = 0;
    char *inFN = NULL, cmd[1024];
    FILE *pp;

    while ((c = getopt(argc, argv, "Ddli:")) != EOF) {
        switch (c) {
        case 'D':       // parser debugging
#if YYDEBUG
            yydebug = 1;
#endif
            break;

        case 'd':
            debugging++;
            break;

        case 'i':
            inFN = optarg;
            break;

        case 'l':
            lflg++;
            break;

        default:
            exit(1);
        }
    }

    verifyStrings();

    // just generate Locale.lua?
    if (lflg) {
        genLocale();
        exit(had_error ? 1 : 0);
    }

    if (inFN == NULL) {
        fprintf(stderr, "Error: no filename given\n");
        exit(1);
    }

    filename = inFN;
    lineno = 1;

    // run the C preprocessor on our input
    if (snprintf(cmd, sizeof(cmd), "%s %s", CMD_CPP, filename) >= sizeof(cmd)){
        fprintf(stderr, "cmd overflow\n");
        exit(1);
    }
    if ((pp = popen(cmd, "r")) == NULL) {
        fprintf(stderr, "popen(\"%s\"): %s\n", cmd, strerror(errno));
        exit(1);
    }

    lex_init(pp);
    while(yyparse())
        ;

    // The DestroDummies:onUpdate() function relies on both of these
    // routines being non-nil, so guarantee it.
    if (!have_incombat) {
        fprintf(stderr, "Error: missing incombat routine\n");
        exit(1);
    }
    if (!have_oocombat) {
        fprintf(stderr, "Error: missing oocombat routine\n");
        exit(1);
    }

    exit(had_error ? 1 : 0);
}

/*
 *  convert an aura to a clip variable for that aura.  Return a pointer
 *  to it in static storage (will be overwritten on the next call)
 */
static char *
aura2clip (int aura)
{
    static char clipstring[100];

    snprintf(clipstring, sizeof clipstring, "clip%d", aura);
    return clipstring;
}

/*
 *  We cannot use calls on Utility functions until we are inside the combat or
 *  nocombat routines (DestroDummies.lua will not have been loaded before we
 *  try to use them otherwise).  Fail if we are unable to use them
 */
static void
utilCheck (void)
{
    if (!utilOK) {
        fprintf(stderr, "%s:%d: Attempt to use a utility function outside "
                "of called routine\n", filename, lineno);
        had_error = 1;
    }
}

static char *
proc_builtin_mx (enum built_in proc, int mIndex)
{
    char *retval;

    switch (proc) {
    case BI_MXBUFF:
        utilCheck();
        retval = amalloc(200);
        sprintf(retval, "DestroDummies:utilMxBuff(mIndexBase + %d)", mIndex);
        return retval;

    case BI_MXBUFF_BY_ME:
        utilCheck();
        retval = amalloc(200);
        sprintf(retval, "DestroDummies:utilMxBuffByMe(mIndexBase + %d)",
                mIndex);
        return retval;

    case BI_MXDEBUFF:
        utilCheck();
        retval = amalloc(200);
        sprintf(retval, "DestroDummies:utilMxDebuff(mIndexBase + %d)",
                mIndex);
        return retval;

    case BI_MXDEBUFF_BY_ME:
        utilCheck();
        retval = amalloc(200);
        sprintf(retval, "DestroDummies:utilMxDebuffByMe(mIndexBase + %d)",
                mIndex);
        return retval;

    default:
        fprintf(stderr, "Unknown proc (%d) in proc_builtin_mx.  Var %d\n",
                proc, mIndex);
        exit(1);
    }
}

static char *
proc_builtin_mx2 (enum built_in proc, int mIndex, char *spell)
{
    char *retval;

    switch (proc) {
    case BI_MXNEED:
        utilCheck();
        retval = amalloc(200);
        sprintf(retval, "DestroDummies:utilMxNeedDebuff(mIndexBase + %d, %s)",
                mIndex, spell);
        return retval;

    default:
        fprintf(stderr, "Unknown proc (%d) in proc_builtin_mx2.  Var %d\n",
                proc, mIndex);
        exit(1);
    }
}

static char *
proc_builtin1 (enum built_in proc)
{
    char *retval;

    switch (proc) {
    case BI_DUAL_WIELDING:
        return astrdup("(GetInventoryItemID(\"player\", DestroDummies.offhandSlotNum) ~= nil)");

    case BI_DISTANCE:
        return astrdup("DestroDummies:distanceToTarget()");

    case BI_FERRALMODE:
        utilCheck();
        retval = astrdup("DestroDummiesPCdb.ferralMode");
        return retval;

    case BI_TAPPED:
        retval = astrdup("(UnitIsTapped(\"target\") and not UnitIsTappedByPlayer(\"target\"))");
        return retval;

    case BI_BOSS:
        utilCheck();
        retval = astrdup("DestroDummies:utilBoss()");
        return retval;

    case BI_ONTANK:
        utilCheck();
        retval = astrdup("DestroDummies:utilOnTank()");
        return retval;

    case BI_UPTIME:
        return astrdup("GetTime()");

    case BI_COMBOPOINTS:
        return astrdup("GetComboPoints(\"player\", \"target\")");

    case BI_MOUNTED:
        return astrdup("IsMounted()");

    case BI_FLAGGEDPVP:
        return astrdup("UnitIsPVP(\"player\")");

    case BI_FLIGHTTIME:
        utilCheck();
        retval = astrdup("DestroDummies:utilFlightTime()");
        return retval;

    case BI_THREAT:
        utilCheck();
        retval = astrdup("DestroDummies:utilThreat()");
        return retval;

    case BI_HASPET:
        // Note that UnitExists("pet") won't work because it will return
        // true when you are on a vehicle even though the pet isn't out
        retval = astrdup("HasPetUI()");
        return retval;

    case BI_PETEXISTS:
        retval = astrdup("UnitExists(\"pet\")");
        return retval;

    case BI_PETHEALTH:
        utilCheck();
        retval = astrdup("DestroDummies:utilHealth(\"pet\")");
        return retval;

    case BI_PLAYERHEALTH:
        utilCheck();
        retval = astrdup("DestroDummies:utilHealth(\"player\")");
        return retval;

    case BI_RAWPLAYERHEALTH:
        utilCheck();
        retval = astrdup("DestroDummies:utilRawHealth(\"player\")");
        return retval;

    case BI_RAWPLAYERMAXHEALTH:
        retval = astrdup("UnitHealthMax(\"player\")");
        return retval;

    case BI_TARGETHEALTH:
        utilCheck();
        retval = astrdup("DestroDummies:utilHealth(\"target\")");
        return retval;

    case BI_TIMETODIE:
        utilCheck();
        retval = astrdup("DestroDummies:utilTimeToDie()");
        return retval;

    case BI_IN_PARTY:
        retval = astrdup("IsInGroup()");
        return retval;

    case BI_IN_RAID:
        retval = astrdup("IsInRaid()");
        return retval;

    case BI_SOLO:
        retval = astrdup("(not IsInGroup())");
        return retval;

    default:
        fprintf(stderr,
                "%s:%d: Error: call to proc_builtin1 with unknown proc (%d)\n",
                filename, lineno, proc);
        exit(1);
    }
}

static char *
proc_builtin2 (enum built_in proc, const struct thing * const thing)
{
    char *retval;
    int spell;

    // we should probably handle auras differently from spells somehow
    spell = thing->index;

    switch (proc) {
    case BI_SPELLTEXT:
        utilCheck();
        retval = amalloc(80);
        sprintf(retval, "GetSpellDescription(%d)", spell);
        return retval;


    case BI_CHARGES:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilCharges(%d)", make_aura(thing));
        return retval;

    case BI_CHARGEINFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilChargeInfo(%d)", make_aura(thing));
        return retval;

    case BI_REQUIRED_POWER:
        retval = amalloc(25);
        // they removed the cost from GetSpellInfo.  So we have to hard-code
        // the information
        sprintf(retval, "%d", wow_cost(spell));
        return retval;

    case BI_TOTEM: {
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilTotem(%d)", spell);
        return retval;
    }

    case BI_BUFF: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilBuff(%d, %s, \"player\", "
                                              "\"HELPFUL\", nil)",
                make_aura(thing), clip);
        return retval;
    }

    case BI_BUFF_BY_ME: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilBuff(%d, %s, \"player\","
                                                "\"HELPFUL\", \"player\")",
                make_aura(thing), clip);
        return retval;
    }

    case BI_PLAYER_DEBUFF: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilBuff(%d, %s, \"player\","
                                                "\"HARMFUL\", nil)",
                make_aura(thing), clip);
        return retval;
    }

    case BI_PETBUFF: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilBuff(%d, %s, \"pet\","
                                                "\"HELPFUL\", nil)",
                make_aura(thing), clip);
        return retval;
    }

    case BI_DEBUFF_BY_ME: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilDebuffByMe(%d, %s)",
                make_aura(thing), clip);
        return retval;
    }

    case BI_DEBUFF_BY_ANY: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilDebuff(%d, %s)",
                make_aura(thing), clip);
        return retval;
    }

    case BI_BUFF_TIME:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilBuffTime(%d)", make_aura(thing));
        return retval;

    case BI_AURA_COUNT:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilAuraCount(\"player\", %d)",
                make_aura(thing));
        return retval;

    case BI_DEBUFF_TIME:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval,
                "DestroDummies:utilDebuffTime(%d, false)", make_aura(thing));
        return retval;

    case BI_DEBUFF_BY_ME_TIME:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval,
                "DestroDummies:utilDebuffTime(%d, true)", make_aura(thing));
        return retval;

    case BI_BUFF_INFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilBuffInfo(%d, false, \"player\")",
                make_aura(thing));
        return retval;

    case BI_DEBUFF_BY_ME_INFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilDebuffByMeInfo(%d)",
                make_aura(thing));
        return retval;

    case BI_PETBUFF_INFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilBuffInfo(%d, false, \"pet\")",
                make_aura(thing));
        return retval;

    case BI_DEBUFF_INFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilBuffInfo(%d, true, \"target\")",
                make_aura(thing));
        return retval;

    case BI_PLAYER_DEBUFF_INFO:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilBuffInfo(%d, true, \"player\")",
                make_aura(thing));
        return retval;

    case BI_CREATURETYPE:
        retval = amalloc(250);
        sprintf(retval, "(UnitCreatureType(\"target\") == %d)", spell);
        return retval;

    case BI_LASTCAST:
        retval = amalloc(250);
        sprintf(retval, "(DestroDummies.lastSpell == %d)", spell);
        return retval;

    case BI_KNOWSSPELL:
        retval = amalloc(250);
        sprintf(retval, "(GetSpellInfo(%d) ~= nil)", spell);
        return retval;

    case BI_CASTABLE:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:spellReady(%d)", spell);
        return retval;

    case BI_INRANGE:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilSpellInRange(%d)", spell);
        return retval;

    case BI_RANGED:
        // Any distance > 9.9 yards is always ranged, or check spell
        retval = amalloc(250);
        sprintf(retval, "((CheckInteractDistance(\"target\", 3) == nil) or (IsSpellInRange(%d) == 1))", spell);
        return retval;

    case BI_WEAPONENHANCE: {
        char *clip;

        utilCheck();
        clip = find_clip(thing);
        retval = amalloc(250 + strlen(clip));
        sprintf(retval, "DestroDummies:utilWeaponEnhance(%s)", clip);
        return retval;
    }

    case BI_GCD: {
        char *upname;

        utilCheck();
        upname = upstring(classname);
        retval = amalloc(250 + strlen(upname));
        sprintf(retval, "(DestroDummies:computeGCD(\"%s\", %d))",upname,spell);
        free(upname);
        return retval;
    }

    case BI_COOLDOWN:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:cooldownTime(%d)", spell);
        return retval;

    default:
        fprintf(stderr,
                "%s:%d: call to proc_builtin2 with unknown proc (%d)\n",
                filename, lineno, proc);
        fprintf(stderr, "Spell was %d\n", spell);
        exit(1);
    }
}

static char *
proc_builtin3 (enum built_in proc, char *expr)
{
    char *retval;

    switch (proc) {
    case BI_STANCE:
        utilCheck();
        retval = amalloc(250 + strlen(expr));
        sprintf(retval, "DestroDummies:utilStance(%s)", expr);
        return retval;

    case BI_FLOOR:
        retval = amalloc(250 + strlen(expr));
        sprintf(retval, "math.floor(%s)", expr);
        return retval;

    case BI_TOTEMTYPE:
        utilCheck();
        retval = amalloc(250 + strlen(expr));
        sprintf(retval, "DestroDummies:utilTotemType(%s)", expr);
        return retval;

    default:
        fprintf(stderr,
                "Error: call to proc_builtin3 with unknown proc (%d)\n", proc);
        fprintf(stderr, "Expr was %s\n", expr);
        exit(1);
    }
}

static void
have_clip (int aura, char *clip)
{
    struct cliplist *new;

    new = amalloc(sizeof(*new));
    new->next = firstclip;
    firstclip = new;

    // special-case: spells ending in () don't get those put in the clip,
    // because they won't show up in the buff/debuff we are looking at
    new->aura = aura;
    new->clip = astrdup(clip);
}

// Return the constant name we use to get the power information.  These
// can be found at http://wow.gamepedia.com/PowerType
static char *
power_string (char *type)
{
    static struct {
        char *power, *constant;
    } map[] = {
        { "mana",               "SPELL_POWER_MANA" },
        { "rage",               "SPELL_POWER_RAGE" },
        { "focus",              "SPELL_POWER_FOCUS" },
        { "energy",             "SPELL_POWER_ENERGY" },
        { "combo_points",       "SPELL_POWER_COMBO_POINTS" },
        { "runes",              "SPELL_POWER_RUNES" },
        { "runic_power",        "SPELL_POWER_RUNIC_POWER" },
        { "soul_shards",        "SPELL_POWER_SOUL_SHARDS" },
        { "eclipse",            "SPELL_POWER_ECLIPSE" },
        { "holy",               "SPELL_POWER_HOLY_POWER" },
        { "alternate",          "SPELL_POWER_ALTERNATE_POWER_INDEX" },
        { "dark_force",         "SPELL_POWER_DARK_FORCE" },
        { "chi",                "SPELL_POWER_CHI" },
        { "shadow_orbs",        "SPELL_POWER_SHADOW_ORBS" },
        { "burning_embers",     "SPELL_POWER_BURNING_EMBERS" },
        { "demonic_fury",       "SPELL_POWER_DEMONIC_FURY" },
    };
    char *quote = NULL;
    int i;

    // strip the leading and trailing quotes, if present
    if (*type == '"') {
        type++;
        if ((quote = strrchr(type, '"')) != NULL)
            *quote = '\0';
    }

    for (i = 0 ; i < NELEM(map) ; i++) {
        if (!strcasecmp(map[i].power, type)) {
            if (quote != NULL)
                *quote = '"';
            return map[i].constant;
        }
    }

    fprintf(stderr, "%s:%d Unknown power type: \"%s\"\n",
            filename, lineno, type);
    exit(1);
}

static char *
proc_builtin4 (enum built_in proc, char *string)
{
    // for mapping between useful strings and WoW rune numbers
    static struct {
        char *runestr;
        int runeid;
    } runemap[] = {
        { "\"blood\"",  1 },
        { "\"unholy\"", 2 },
        { "\"frost\"",  3 },
    };
    char *retval, *pstring;
    int rNum, rune;

    switch (proc) {
    case BI_POWER:
        utilCheck();
        if (string == NULL) {
            return astrdup("((UnitPower(\"player\") * 100) / "
                           "UnitPowerMax(\"player\"))");
        } else {
            retval = amalloc(250);
            pstring = power_string(string);
            snprintf(retval, 250, "((UnitPower(\"player\", %s) * 100) /"
                     "UnitPowerMax(\"player\", %s))", pstring, pstring);
            return retval;
        }
        break;

    case BI_RAWPOWER:
        utilCheck();
        if (string == NULL) {
            return astrdup("UnitPower(\"player\")");
        } else {
            retval = amalloc(250);
            pstring = power_string(string);
            snprintf(retval, 250, "UnitPower(\"player\", %s)", pstring);
            return retval;
        }
        break;

    case BI_MAXPOWER:
        utilCheck();
        if (string == NULL) {
            return astrdup("UnitPowerMax(\"player\")");
        } else {
            retval = amalloc(250);
            pstring = power_string(string);
            snprintf(retval, 250, "UnitPowerMax(\"player\", %s)", pstring);
            return retval;
        }
        break;

    case BI_RUNE_COUNT:
        utilCheck();
        if (string == NULL) {
            fprintf(stderr, "%s:%d Error: missing rune type\n", filename,
                    lineno);
            exit(1);
        }

        for (rNum = 0 ; rNum < NELEM(runemap) ; rNum++)
            if (!strcasecmp(runemap[rNum].runestr, string))
                break;
        if (rNum >= NELEM(runemap)) {
            fprintf(stderr, "%s:%d: Unknown rune type %s\n", filename,
                    lineno, string);
            exit(1);
        }
        rune = runemap[rNum].runeid;

        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilRuneCount(%d)", rune);
        return retval;

    default:
        fprintf(stderr, "%s:%d "
                "Error: call to proc_builtin4 with unknown proc (%d)\n",
                filename, lineno, proc);
        fprintf(stderr, "String was %s\n", string);
        exit(1);
    }
}

// built-ins that take 3 parameters
static char *
proc_builtin5 (enum built_in proc, char *p1, char *p2, char *p3)
{
    char *retval;

    switch (proc) {
    case BI_HAVE_RUNES:
        utilCheck();
        retval = amalloc(BIG_NUMBER);
        snprintf(retval, BIG_NUMBER, "DestroDummies:utilHaveRunes(%s, %s, %s)",
                 p1, p2, p3);
        return retval;

    default:
        fprintf(stderr, "%s:%d: call to %s with unknown proc (%d)\n",
                filename, lineno, __FUNCTION__, proc);
        exit(1);
    }
}

// the item is either a variable holding the item number, or the number as
// a string
static char *
proc_builtin6 (enum built_in proc, struct thing *thing)
{
    char *retval;

    switch (proc) {
    case BI_ITEMBUFF:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval,
                "DestroDummies:utilBuff(%d, 0, \"player\", \"HELPFUL\", nil)",
                make_aura(thing));
        return retval;

    case BI_IN_BAG:
        utilCheck();
        retval = amalloc(80);
        sprintf(retval, "DestroDummies:utilItemInBag(%d)", thing->index);
        return retval;

    default:
        fprintf(stderr, "%s:%d: call to %s with unknown proc (%d)\n",
                filename, lineno, __FUNCTION__, proc);
        exit(1);
    }
}

static char *
proc_builtin7 (enum built_in proc, int glyph)
{
    char *retval;

    switch (proc) {
    case BI_HASGLYPH:
        utilCheck();
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilHasGlyph(%d)", glyph);
        return retval;

    default:
        fprintf(stderr, "%s:%d: call to %s with unknown proc (%d)\n",
                filename, lineno, __FUNCTION__, proc);
        exit(1);
    }
}

static char *
proc_builtin8 (enum built_in proc, const struct thing * const thing)
{
    char *retval;
    int talent;

    switch (proc) {
    case BI_TALENT:
        utilCheck();
        if ((talent = make_talent(thing)) == 0) {
            fprintf(stderr, "%s:%d: unknown talent %s\n", filename, lineno,
                    thing->name);
            had_error = 1;
        }
        retval = amalloc(250);
        sprintf(retval, "DestroDummies:utilTalent(%d)", talent);
        return retval;

    default:
        fprintf(stderr, "%s:%d: call to %s with unknown proc (%d)\n",
                filename, lineno, __FUNCTION__, proc);
        exit(1);
    }
}

static char *proc_builtin9 (const enum built_in proc,
                            const char * const text, const char * const count)
{
    char *retval;

    switch (proc) {
    case BI_SCAN_NUMBERS:
        utilCheck();
        retval = amalloc(80 + strlen(text));
        sprintf(retval, "DestroDummies:utilScanNumbers(%s, %s)",
                text, count);
        return retval;

    default:
        fprintf(stderr, "%s:%d: call to %s with unknown proc (%d)\n",
                filename, lineno, __FUNCTION__, proc);
        exit(1);
    }
}

char *
find_clip (const struct thing * const thing)
{
    struct cliplist *cur;
    int aura;

    aura = make_aura(thing);
    for (cur = firstclip ; cur != NULL ; cur = cur->next) {
        if (aura == cur->aura)
            return cur->clip;
    }
    return "0";
}

// convert str to start with upper case, the rest lower case
char *
normalize (char *string)
{
    char *str;

    *string = toupper(*string);
    for (str = &string[1] ; *str != '\0' ; str++)
        *str = tolower(*str);

    return string;
}

// Allocate memory to copy the string to, making it all upper case
static char *
upstring (char *string)
{
    char *upstr, *cur;

    upstr = astrdup(string);
    for (cur = upstr ; *cur != '\0' ; cur++)
        *cur = toupper(*cur);
    return upstr;
}

char *
astrdup (const char *from)
{
    char *retval;

    if ((retval = strdup(from)) == NULL) {
        perror("strdup");
        exit(1);
    }
    return retval;
}

void *
amalloc (int n)
{
    void *retval;

    if ((retval = malloc(n)) == NULL) {
        perror("malloc");
        exit(1);
    }
    return retval;
}

int
yyerror (char *str)
{
    fprintf(stderr, "%s:%d: error: %s at %s\n", filename, lineno, str, yytext);
    exit(1);
}

static char *
intstring (const int i)
{
    char *ret;

    ret = amalloc(40);
    snprintf(ret, 40, "%d", i);
    return ret;
}
